//̓t@NVfoCXhCo dǗ̗ł
//foCXp[̐̓oXfoCXhCosĂ̂ŁC
//VXep[̐SƂR[hɂȂĂ

NTSTATUS
UsbDriverSample_ProcessPowerIrp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PIO_STACK_LOCATION  irpStack;

    deviceExtension = DeviceObject->DeviceExtension;
    irpStack = IoGetCurrentIrpStackLocation (Irp);

    // d͊Ǘ̊e͂̂悤ɗv
    switch (irpStack->MinorFunction) {

    case IRP_MN_SET_POWER:
        
        // ----------- p[ɂ ----------
        // ́Ct@NVfoCXhCo̗ł
        // foCXp[ɂẮCoXfoCXhCoɔCāC
        // VXep[ɂ̂݁CΉR[hɂȂĂ
        switch (irpStack->Parameters.Power.Type) {

        case SystemPowerState:
        // VXep[USBt@NVfoCXhCo
        // ʓ|
        return SystemSetPower(DeviceObject,Irp);

        case DevicePowerState:
        // foCXp[̕ύX
        // KvȂ΂ɏ
            break;

        }

        break;

    case IRP_MN_QUERY_POWER:

        switch (irpStack->Parameters.Power.Type) {

        case SystemPowerState:
        // VXep[ύXĂ悢₢킹Ă
        // KvȂ΂ɏ
        break;

        case DevicePowerState:
        // foCXp[ύXĂ悢₢킹Ă
        // KvȂ΂ɏ
        break;

        }

        break;

    default:
        break;

    }

    // ʂ̃foCXhCoɏۓĂ
    // d͊Ǘsꍇ́Cȉ̃R[ĥ悤
    // PoStartNextPowerIrpCPoCallDriverƂ
    // Po????? Ƃ`APIg
    PoStartNextPowerIrp( Irp);
    IoSkipCurrentIrpStackLocation(Irp);

    ntStatus = PoCallDriver (deviceExtension->
					StackDeviceObject, Irp);

    return ntStatus;
}

// foCXp[ݒ芮[`̃p[^ɂȂ
typedef struct _POWER_COMPLETION_CONTEXT {

    // foCXIuWFNg
    PDEVICE_OBJECT DeviceObject;
    // VXe甭sꂽd͊ǗIRP
    PIRP           Irp;          
} POWER_COMPLETION_CONTEXT, *PPOWER_COMPLETION_CONTEXT;

//VXep[ł́Cݒ肳ꂽVXep[
//ΉfoCXp[ݒ肷鏈s
NTSTATUS SystemSetPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    NTSTATUS							ntStatus;
    POWER_STATE						powerState;
    PDEVICE_EXTENSION				deviceExtension;
    PIO_STACK_LOCATION			irpStack;
    SYSTEM_POWER_STATE				systemState;
    DEVICE_POWER_STATE				deviceState;
    PPOWER_COMPLETION_CONTEXT	powerContext;

    deviceExtension = (PDEVICE_EXTENSION)DeviceObject->
					DeviceExtension;
    irpStack = IoGetCurrentIrpStackLocation(Irp);

    // VXeXe[^X擾
    systemState = irpStack->Parameters.Power.State.SystemState;
    
    // J[lݒ肵VXep[Xe[gɑΉ
    // foCXXe[gݒ肷ɂ́CɓK؂Ȓl
    // (jVXe_E4CVXeAbv1
    deviceState = DEVICE_STATE;
    powerState.DeviceState = deviceState;
    
    // p[䊮֐̃p[^mۂāCꂼݒ肷

    powerContext = (PPOWER_COMPLETION_CONTEXT) 
                   ExAllocatePool(NonPagedPool,
                          sizeof(POWER_COMPLETION_CONTEXT));
    powerContext->DeviceObject = DeviceObject;
    powerContext->Irp = Irp;
   
    // foCX̃p[Zbg𔭍s
    ntStatus = PoRequestPowerIrp(
        deviceExtension->PhysicalDeviceObject, 
        irpStack->MinorFunction,
        powerState,  // foCXp[Xe[gXVĂ
        (PREQUEST_POWER_COMPLETE)DevicePowerSetComplete,
        powerContext, 
        NULL);

    if(NT_SUCCESS(ntStatus))
        return ntStatus; // ȂΏI

    // sꍇ́C̃p[}l[WgIRP
       
    PoStartNextPowerIrp(Irp);
    Irp->IoStatus.Status = ntStatus;
    Irp->IoStatus.Information = 0;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    if(powerContext) {
        ExFreePool(powerContext);
    }

    return ntStatus;
}

//foCXp[䏈ƁCꂪĂ΂

VOID DevicePowerSetComplete(
    IN PDEVICE_OBJECT DeviceObject, 
    IN UCHAR MinorFunction,
    IN POWER_STATE PowerState,
    IN PVOID Context,
    IN PIO_STATUS_BLOCK IoStatus
    )
{
    PIRP                      Irp;
    PDEVICE_EXTENSION         deviceExtension;
    PPOWER_COMPLETION_CONTEXT powerContext;
   
    powerContext = (PPOWER_COMPLETION_CONTEXT) Context;
    Irp = powerContext->Irp;
    deviceExtension = powerContext->DeviceObject->
					DeviceExtension;

    ExFreePool(powerContext);

    // ̃p[}l[WgIRP悤ɂ
    PoStartNextPowerIrp(Irp);
	IoSkipCurrentIrpStackLocation(Irp);

    // ʂ̃foCXhCoIRP𓊂邱ƂŁC
    // VXep[Xe[gI
    PoCallDriver (deviceExtension->StackDeviceObject, Irp);
}
