UsbDriverSample_ProcessIOCTL(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
    NTSTATUS            ntStatus;
    PIO_STACK_LOCATION  irpStack;
    PVOID               ioBuffer;
    ULONG               inputBufferLength, outputBufferLength;

    irpStack            = IoGetCurrentIrpStackLocation (Irp);

    // obt@[hI/Õobt@擾
    ioBuffer            = Irp->AssociatedIrp.SystemBuffer;
    inputBufferLength   = irpStack->
					Parameters.DeviceIoControl.InputBufferLength;
    outputBufferLength  = irpStack->
					Parameters.DeviceIoControl.OutputBufferLength;

    // R[hɉďU蕪
    switch (irpStack->Parameters.DeviceIoControl.
					IoControlCode) {

    case IOCTL_TEST_READ:

        // f[^͓ǂݎ̂Ăł
        // {͂ŃfoCXւ̐s

        // ]oCgݒ肷
        Irp->IoStatus.Information = outputBufferLength;
        break;

    case IOCTL_TEST_WRITE:

        // {͂ŃfoCXւ̐sC
        // łׂ͂0ŏIƂĂ
        RtlZeroMemory(ioBuffer,inputBufferLength);

        // ]oCgݒ肷
        Irp->IoStatus.Information = inputBufferLength;
        break;

    default:
        ntStatus = STATUS_INVALID_PARAMETER;
    }

    // IRP̉Xe[^Xݒ肵IRPĂ
    Irp->IoStatus.Status = ntStatus;
    IoCompleteRequest (Irp, IO_NO_INCREMENT);

    return ntStatus;
}
