NTSTATUS USB_StartDevice(IN  PDEVICE_OBJECT DeviceObject)
{
    NTSTATUS ntStatus;
    ULONG configurationDescriptorSize;
    PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor = 
				NULL;

    // RtBM[V̑Sf[^m邽߂
    // ܂̓RtBM[VfBXNv^݂̂擾

    configurationDescriptorSize = 
					sizeof(USB_CONFIGURATION_DESCRIPTOR);
    configurationDescriptor = ExAllocatePool(
                NonPagedPool, configurationDescriptorSize+1);

    ntStatus = USB_GetConfigurationDescriptor(
                    DeviceObject,
                    configurationDescriptorSize,
                    configurationDescriptor
                );
    if ( !NT_SUCCESS(ntStatus) )
        goto USB_StartDeviceExit;

    // ɑSRtBM[Vf[^擾
    // RtBM[VfBXNv^wTotalLengthݒ肷
    configurationDescriptorSize = configurationDescriptor->
							wTotalLength;
    ExFreePool(configurationDescriptor);
    configurationDescriptor = ExAllocatePool(
              NonPagedPool, configurationDescriptorSize+1);

    ntStatus = USB_GetConfigurationDescriptor(
                    DeviceObject,
                    configurationDescriptorSize,
                    configurationDescriptor
                );
    if ( !NT_SUCCESS(ntStatus) )
        goto USB_StartDeviceExit;

    // 擾RtBM[Vf[^ƂɁC
    // ZNgRtBM[VsďI
    ntStatus = USB_SelectConfiguration(DeviceObject,
                    configurationDescriptor);

USB_StartDeviceExit:

    if (configurationDescriptor)
        ExFreePool(configurationDescriptor);

    return ntStatus;
}
