NTSTATUS USB_ClassRequest(
    PDEVICE_OBJECT DeviceObject,
    UCHAR   transferFlags,
    UCHAR   request,
    USHORT  value,
    USHORT  index,
    PCHAR   pBuffer,
    ULONG   length
    )
{
    NTSTATUS        ntStatus;
    URB             urb;

    // NXNGXgsURB쐬
    UsbBuildVendorRequest(  &urb,
        URB_FUNCTION_CLASS_INTERFACE,
        (USHORT)sizeof(struct 
							_URB_CONTROL_VENDOR_OR_CLASS_REQUEST),
        transferFlags, 	// ULONG@transferFlags
        0,						// UCHAR@reservedbits
        request, 			// UCHAR@request
        value,				// USHORT@value
        index, 				// USHORT@index
        pBuffer,				// IN PVOID@TransferBuffer
        NULL, 				// IN PMDL@TransferBufferMDL
        length, 				// IN ULONG@TransferBufferLength,
        NULL );				// IN PURB Link )

    // USBzXgRg[hCǒĂяo
    ntStatus = USB_CallUSBD(DeviceObject, &urb);

    return(urb.UrbHeader.Status);
}
