NTSTATUS USB_BulkOrInterruptTransfer(
    PDEVICE_OBJECT DeviceObject,
    PUSBD_PIPE_INFORMATION pipeInformation;
    PCHAR   pBuffer,
    ULONG  length,
    BOOLEAN isRead,
    )
{
    NTSTATUS	ntStatus;
    URB			urb;
    ULONG		usbFlags;

    // USBoN]̃tOݒ肷
    urbFlags = USBD_SHORT_TRANSFER_OK;
    if(isRead) { // ]̐ݒ
       urbFlags |= USBD_TRANSFER_DIRECTION_IN;
    }
    else {
       urbFlags |= USBD_TRANSFER_DIRECTION_OUT;
    }

    // oN܂̓C^vg]URB̍쐬
    UsbBuildInterruptOrBulkTransferRequest(
                    &urb,
                    sizeof(struct 
										_URB_BULK_OR_INTERRUPT_TRANSFER),
                    pipeInformation->PipeHandle,
                    pBuffer,
                    NULL,
                    length,
                    urbFlags,
                    NULL);

    // USBzXgRg[hCoĂяoď
    ntStatus = USB_CallUSBD(DeviceObject, &urb);

    return(urb.UrbHeader.Status);
}
