NTSTATUS USB_IsochronousTransfer
(
    PDEVICE_OBJECT DeviceObject,
    PUSBD_PIPE_INFORMATION PipeInformation,
    PCHAR 	pBuffer,
    ULONG	length,
    BOOLEAN	isRead,
    ULONG	packetSize,
    ULONG	packets,
)
{
    NTSTATUS 	ntStatus;
    PURB			urb;
    ULONG		usbFlags;
    ULONG		i;
    ULONG 		remainderLength = length; //c

    // USBAC\NiX]̃tOݒ肷
    urbFlags = USBD_SHORT_TRANSFER_OK;
    if(isRead) { // ]̐ݒ
       urbFlags |= USBD_TRANSFER_DIRECTION_IN;
    }
    else {
       urbFlags |= USBD_TRANSFER_DIRECTION_OUT;
    }

    // pPbgURB̃TCY擾
    UrbSize = GET_ISO_URB_SIZE(packets);

    // 擾TCYURBmۂ
    urb = (PURB) ExAllocatePool(NonPagedPool, UrbSize);

		// }NȂ̂Œڑ
	urb->UrbIsochronousTransfer.Hdr.Length = UrbSize; 
    urb->UrbIsochronousTransfer.Hdr.Function = 
					URB_FUNCTION_ISOCH_TRANSFER;
    urb->UrbIsochronousTransfer.PipeHandle = pipeInformation->
					PipeHandle;
    urb->UrbIsochronousTransfer.Flags = urbFlags |
           USBD_START_ISO_TRANSFERASAP; // ɊJn
    urb->UrbIsochronousTransfer.TransferBuffer = pBuffer
    urb->UrbIsochronousTransfer.NumberOfPackets = packets;

    // epPbg̃ItZbgƒݒ肷
    for (i=0; i<packets; i++,remainderLength -= packetSize) {
      urb->UrbIsochronousTransfer.IsoPacket[i].Offset = 
					i*packetSize;
      urb->UrbIsochronousTransfer.IsoPacket[i].Length = 
					packetSize;
    }

    // USBzXgRg[hCoĂяoď
    ntStatus = USB_CallUSBD(DeviceObject, &urb);

    ntStatus = urb.UrbHeader.Status; // USB Statusɏ
    ExFreePool(urb);

    return ntStatus;
}
