NTSTATUS USB_CallUSBD(
    IN PDEVICE_OBJECT DeviceObject,
    IN PURB Urb
    )
{
    NTSTATUS ntStatus, status = STATUS_SUCCESS;
    PDEVICE_EXTENSION deviceExtension;
    PIRP irp;
    KEVENT event;
    IO_STATUS_BLOCK ioStatus;
    PIO_STACK_LOCATION nextStack;

    // URBʂ̃foCXhCoɑď˗
    // ICxgő҂

    // deviceExtensionɂUSBoXfoCXhCõIuWFNg
    // ƂiAddDeviceɐݒ肳ĂƉj
    deviceExtension = DeviceObject->DeviceExtension;

    // ʃfoCXhCȍ҂Cxg̏
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // IOCTL_INTERNAL_USB_SUBMIT_URBɂvs
    // IRP쐬
    irp = IoBuildDeviceIoControlRequest(
                IOCTL_INTERNAL_USB_SUBMIT_URB,
                deviceExtension->StackDeviceObject,
                NULL,
                0,
                NULL,
                0,
                TRUE, // IRP_MJ_INTERNAL_DEVICE_CONTROLw肷
                &event,
                &ioStatus);

    // ʃhCoI/OX^bNP[V擾
    nextStack = IoGetNextIrpStackLocation(irp);

    // p[^URBw肷
    nextStack->Parameters.Others.Argument1 = Urb;

    // ʃfoCXhCoioXfoCXhCojɏ˗
    ntStatus = IoCallDriver(deviceExtension->StackDeviceObject,
                            irp);

    // ICxgő҂
    if (ntStatus == STATUS_PENDING)
    {
        ntStatus = KeWaitForSingleObject(
                        &event,
                        Executive,
                        KernelMode,
                        FALSE,
                        NULL);
    }
    else {
        ioStatus.Status = ntStatus;
    }
    ntStatus = ioStatus.Status;

    return ntStatus;
}
