// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    PFILE_OBJECT	fileObject;
    PIO_STACK_LOCATION		irpStack;
    NTSTATUS	ntStatus = STATUS_SUCCESS;

    USB_KdPrint (("Hello World I'm USB_Create \n"));

    irpStack = IoGetCurrentIrpStackLocation(Irp);


    // t@CIuWFNg擾
    fileObject = irpStack->FileObject;
    if(!fileObject) {
        ntStatus = STATUS_INVALID_PARAMETER;
        goto USB_CreateExit;
    }


#if DBG  // \Ȃ̂ŁCfobOɂ̂ݑ݂R[hɂ

    // t@Cl[Ύo
    if(fileObject->FileName.Length) {
        // t@Cl[́CUNICODEƂCWindowsł

        // Ȃ݂2oCg1ƂR[h
        // ŝŁCWCHARC܂2Ŋ
        PUNICODE_STRING FileName = &fileObject->FileName;
        ULONG nameLength = (FileName->Length / sizeof(WCHAR));

		USB_KdPrint(("Filename = %ws nameLength = %d\n", FileName->Buffer, nameLength));
    }

#endif

USB_CreateExit:

    // t@CIuWFNgCreate

    Irp->IoStatus.Status = ntStatus;
    Irp->IoStatus.Information = 0;

    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    return ntStatus;

}


// ---------- IRP_MJ_CLOSE ----------
NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Close \n"));

    // IRP𐬌Ŋ
    Irp->IoStatus.Status = STATUS_SUCCESS;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);
    return STATUS_SUCCESS;
}
