VOID GetConfigurationDescriptor(void)
{
#define OFFSET_USB_INTERFACE_DESCRIPTOR 9
#define OFFSET_USB_INTERFACE_CLASS 5
#define OFFSET_USB_INTERFACE_CLASS_PROTOCOL 7

    ULONG   nBytes;
    UCHAR   buffer[256];
    int     i;

    // RtBM[VfBXNv^iALLjM
    if ( ! DeviceIoControl( hUsbTest,
            IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR,
            NULL,
            0,
            (LPVOID)buffer,
            256, 	//Ƃ肠ő256oCgƂ
                  	//ʏ͂ȉŉ͂ł
            &nBytes,
            NULL
            ) )
    {
        printf("IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR Error! \n");
    }

    // USB̃NXƃvgRĂ
    UsbClass = buffer
                [OFFSET_USB_INTERFACE_DESCRIPTOR
                  + OFFSET_USB_INTERFACE_CLASS];
    UsbProtocol = buffer
                [OFFSET_USB_INTERFACE_DESCRIPTOR
                  + OFFSET_USB_INTERFACE_CLASS_PROTOCOL];

    // Mf[^ƃNXCvgR\
    printf("IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR Success! \n");
    printf("UsbClass=%02x UsbProtocol=%02x \n",UsbClass,UsbProtocol);
    for (i=0; i<(int)nBytes; i++)
        printf("%02x ",buffer[i]);
    printf("\n\n");

}
