NTSTATUS
USB_ResetPipe(
    PDEVICE_OBJECT DeviceObject
)
{
    NTSTATUS                ntStatus;
    URB                     urb;
    PUSBD_PIPE_INFORMATION  pipeInformation;
    PDEVICE_EXTENSION       deviceExtension;

    deviceExtension = DeviceObject->DeviceExtension;
    pipeInformation = deviceExtension->NeedResetPipe;
    if (pipeInformation == NULL)
        return STATUS_SUCCESS; 	// ZbgׂpCv͂Ȃ

    // pCvZbgŝŁCURBɂݒ肷
    urb.UrbHeader.Length		= (USHORT) sizeof(struct 
					_URB_PIPE_REQUEST);
    urb.UrbHeader.Function		= URB_FUNCTION_RESET_PIPE;
    urb.UrbPipeRequest.PipeHandle	= pipeInformation->PipeHandle;

    // pCvZbgʃfoCXhCoɈ˗
    ntStatus = USB_CallUSBD(DeviceObject, &urb);
    if (NT_SUCCESS(ntStatus))
        deviceExtension->NeedResetPipe = NULL;

    USB_KdPrint(("USB_ResetPipe urb.status %x \n",urb.UrbHeader.Status));

    return (urb.UrbHeader.Status);
}
