#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// USBXg[WfoCXւ̒`擾
#include "UsbStorageDevice.h"
#include "CBIStorageDevice.h"
#include "BulkOnlyStorageDevice.h"
typedef struct {
    CHAR AtapiRequestPacket[ATAPI_COMMAND_REQUEST_LENGTH];
    ULONG TransferLength;
    ULONG TransferCompleteLength;
    BOOL isThisRequestRead;
    CHAR *DataBuffer;
} ATAPI_REQUEST_PARAMETER, *PATAPI_REQUEST_PARAMETER;

class CUsbStorageTest
{
public:
    CUsbStorageTest();
    virtual ~CUsbStorageTest();

    // 
    BOOL Initialize(VOID);

    // I
    VOID Release(VOID);

    // ATAPIR}h̃eXg
    BOOL AtapiCommandTest(ATAPI_REQUEST_PARAMETER *AtapiRequest);

    // v_Ng̎擾
    CHAR* GetUsbDeviceProductName(VOID);

    // foCXNX̎擾
    USB_DEVICE_CLASS* GetUsbDeviceClass(VOID);

    // RequestSense̔s
    BOOL GetSenseData(RequestSenseData *SenseDataBuffer);

    // ReadCapacity̔s
    BOOL GetCapacityData(CapacityData *ReadCapacityData);

    // foCXx̃`FbN
    ULONG IsDeviceHighSpeed(VOID);

private:
    USB_DEVICE_CLASS UsbDeviceClass; 		//foCXNX
    CUsbDevice *UsbDevice; 						// USBfoCXNX
    CUsbStorageDevice *UsbStorageDevice; 	// Xg[WfoCXNX
    CHAR ProductName[INQUIRY_PRODUCT_NAME_LENGTH]; // i

    // ATAPINGXg̃p[^
    CHAR atapi[ATAPI_COMMAND_REQUEST_LENGTH];

    // CBIXg[WNXǂ̃`FbN
    BOOL isThisClassCBI(VOID);

    // Inquiry̔s
    BOOL GetInquiryData(VOID);
};
