BOOL CUsbStorageTest::GetSenseData(RequestSenseData *SenseDataBuffer)
{
    ATAPI_REQUEST_PARAMETER atapiRequest;


    // ATAPIR}hpPbgNA
    memset(&atapiRequest.AtapiRequestPacket[0], 0,
        ATAPI_COMMAND_REQUEST_LENGTH);

    // ATAPIR}hݒ肷
    // OP CODE = RequestSense
    atapiRequest.AtapiRequestPacket[0] = 0x03;
    // Allocation Length = RequestSense Data
    atapiRequest.AtapiRequestPacket[4] = sizeof(RequestSenseData);
    // f[^̕Cobt@CTCYݒ肷
    atapiRequest.isThisRequestRead = TRUE;
    atapiRequest.DataBuffer = (CHAR *)SenseDataBuffer;
    atapiRequest.TransferLength = sizeof(RequestSenseData);

    // ATAPIR}heXgŏ
    if ( !AtapiCommandTest(&atapiRequest) )
        return FALSE;
    else
        return TRUE;

}

BOOL CUsbStorageTest::GetCapacityData(CapacityData *ReadCapacityData)
{
    ATAPI_REQUEST_PARAMETER atapiRequest;

    // ATAPIR}hpPbgNA
    memset(&atapiRequest.AtapiRequestPacket[0], 0,
        ATAPI_COMMAND_REQUEST_LENGTH);

    // ATAPIR}hݒ肷
    // OP CODE = ReadCapacity
    atapiRequest.AtapiRequestPacket[0] = 0x25;

    // f[^̕ƃobt@CTCYݒ肷
    atapiRequest.isThisRequestRead = TRUE;
    atapiRequest.DataBuffer = (CHAR *)ReadCapacityData;
    atapiRequest.TransferLength = sizeof(CapacityData);

    // ATAPIR}heXgŏ
    if ( !AtapiCommandTest(&atapiRequest) )
        return FALSE;
    else
        return TRUE;
}

BOOL CUsbStorageTest::GetInquiryData(VOID)
{
    CHAR    InquiryDataBuffer[36];
    ATAPI_REQUEST_PARAMETER atapiRequest;

    // ATAPIR}hpPbgNA

    memset(&atapiRequest.AtapiRequestPacket[0], 0,
        ATAPI_COMMAND_REQUEST_LENGTH);

    // ATAPIR}hݒ
    // OP CODE = Inquiry
    atapiRequest.AtapiRequestPacket[0] = 0x12;
    // Allocate Length = 36;
    atapiRequest.AtapiRequestPacket[4] = 36;

    // f[^̕Cobt@CTCYݒ肷

    atapiRequest.isThisRequestRead = TRUE;
    atapiRequest.DataBuffer = (CHAR *)InquiryDataBuffer;
    atapiRequest.TransferLength = 36;

    // ATAPIR}heXgŏ
    if ( !AtapiCommandTest(&atapiRequest) )
        return FALSE;

    // v_Ng𒊏oĊi[
    // v_Ng̓ItZbg1616oCgɂȂi\2-21QƁj
    memcpy(ProductName,&InquiryDataBuffer[16],16);

    return TRUE;
}
