BOOL CUsbDevice::GetUsbDeviceClass(USB_DEVICE_CLASS *UsbDeviceClass)
{
#define INTERFACE_DESCRIPTOR_OFFSET 9
#define INTERFACE_CLASS_OFFSET      5

    UCHAR   ConfigurationDescriptor[256];
    BOOL    CouldGetConfigurationDescriptor;
    ULONG   TransferCompleteSize;

    // RtBM[VfBXNv^iALLjM
    CouldGetConfigurationDescriptor =
        DeviceIoControl( HandleOfUsbDeviceDriver,
            IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR,
            NULL,
            0,
            (LPVOID)ConfigurationDescriptor,
            256,  // Ƃ肠ő256oCgƂ
                  // ʏ͂ȉŉ͂ł
            &TransferCompleteSize,
            NULL
            );

    // foCX̃NXCTuNXCvgRRs[
    memcpy( UsbDeviceClass,
        &ConfigurationDescriptor[
          INTERFACE_DESCRIPTOR_OFFSET + INTERFACE_CLASS_OFFSET],
        sizeof(USB_DEVICE_CLASS) );

   return CouldGetConfigurationDescriptor;
}
