NTSTATUS UsbtestDevice::IOCTL_USB_CLASS_REQUEST_Handler(KIrp I)
{
    NTSTATUS status = STATUS_SUCCESS;
    ULONG    size = 0;
    PURB     urb;

#define ATAPI_PACKET_SIZE 12

    t << "Entering UsbtestDevice::IOCTL_USB_CLASS_REQUEST_Handler, " << I << EOL;

    // NXNGXgURB쐬
    urb = m_Lower.BuildClassRequest(
           (PUCHAR)I.IoctlBuffer(), // PUCHAR TransferBuffer,
           ATAPI_PACKET_SIZE,  //ULONG TransferBufferLength,
           0,       //UCHAR RequestTypeReservedBits,
           0,       //UCHAR Request,
           0,       //USHORT Value,
           FALSE,   //BOOLEAN bIn=FALSE,
           TRUE,    //BOOLEAN bShortOk=FALSE,
           NULL,    //PURB Link=NULL,
           0,       //UCHAR Index=0,
           URB_FUNCTION_CLASS_INTERFACE , // USHORT Function
           NULL     //PURB pUrb=NULL
        );

    // NXNGXg̔s
    status = m_Lower.SubmitUrb(urb,NULL,NULL,0);

    I.Information() = ATAPI_PACKET_SIZE;// ]TCY̐ݒ
    I.Status() = status;

    return status;
}
