// WindowsŃhCo𐧌䂷ꍇ͂ 
// t@CCN[hKv
#include "windows.h"
#include "setupapi.h"
#include "stdio.h"
#include "initguid.h"
#include "winioctl.h"

// ̓foCXhCousbtest.sys֘Ȁł
// pX͕M҂̂̂ɂȂĂ̂ŁC̊ɍ킹Kv
#include "..\..\sys\usbtest.h"

#define DEVICE_PATH_NAME_LENGTH 1024

// RtBO[VfBXNv^֘A̒`
#define USB_CLASS_MASS_STORAGE 8
#define USB_STORAGE_BULK_ONLY_CLASS 0x50

// ֐̒`
HANDLE CreateDeviceFile(GUID *pGuid, ULONG instance,CHAR* filename);
VOID GetConfigurationDescriptor(VOID);
VOID WdmReadWriteTest(VOID);
VOID InquiryTest(VOID);
BOOL SendAtapiCommandPacket(PUCHAR atapi,ULONG TransferLength);
BOOL BulkOnlyCSWRead(VOID);

// O[oϐ
HANDLE hUsbTest;
UCHAR UsbClass;
UCHAR UsbProtocol;

int main(int argc, char* argv[])
{
    CHAR *filename = "usbtest";
    char key;

    printf("UsbDosTest Main \n");

    // foCXhCousbtest.sys̃I[v
    hUsbTest = CreateDeviceFile(
        (LPGUID)&USBTEST_GUID,0,filename);
    if (!hUsbTest) {
        printf("CreateDeviceFile error ! \n");
        goto Main_End;    }
    printf("CreateDeviceFile Success! \n");

    // RtBM[VfBXNv^擾
    GetConfigurationDescriptor();

    // InquirỹeXg
    InquiryTest();

    // foCXhCõN[Y
    CloseHandle(hUsbTest);

Main_End:
    scanf("%c",&key); // ɏIȂ悤ɓ͑҂

    return 0;
}

HANDLE CreateDeviceFile(GUID *pGuid, ULONG instance,
					CHAR* filename)
{
    HDEVINFO DeviceInformationHandle;
    SP_INTERFACE_DEVICE_DATA    InterfaceDeviceData;
    PSP_INTERFACE_DEVICE_DETAIL_DATA InterfaceDeviceDetailData;
    DWORD SizeOfSymbolicName;
    HANDLE DeviceHandleWithFileName=NULL;
    UCHAR DevicePathName[DEVICE_PATH_NAME_LENGTH];

    InterfaceDeviceDetailData = NULL;
    memset(&DevicePathName,0,DEVICE_PATH_NAME_LENGTH);

    // GUIDɑΉ񂪂\HDEVINFO擾
    DeviceInformationHandle =
        SetupDiGetClassDevs(pGuid, NULL, NULL, DIGCF_PRESENT | 
DIGCF_INTERFACEDEVICE);
    if(DeviceInformationHandle==INVALID_HANDLE_VALUE)
        return NULL;

    // 擾HDEVINFOɑCX^XŎw肵
    // foCX̃C^[tF[X\̂擾
    // ̓foCXꍇ́CinstanceőIł
    // Pڂ0ɂȂ
    InterfaceDeviceData.cbSize = sizeof(InterfaceDeviceData);
    if( !SetupDiEnumDeviceInterfaces(
            DeviceInformationHandle,
            NULL, pGuid, instance, &InterfaceDeviceData) )
    {
        goto CreateUsbDeviceFile_Exit;
    }

    // ɏڍׂȃC^[tF[Xf[^擾
    // 킩Ȃ̂ŁC܂͒0Ŏ擾
    // ̓G[ŉ邪C̎擾ړIȂ̂Ŗ
    SetupDiGetDeviceInterfaceDetail(
        DeviceInformationHandle,&InterfaceDeviceData,
        NULL, 0, &SizeOfSymbolicName, NULL);

    // 擾TCYƂɁCC^[tF[X̏ڍׂȃf[^mۂ
    InterfaceDeviceDetailData =
            (PSP_INTERFACE_DEVICE_DETAIL_DATA)
								malloc(SizeOfSymbolicName);
    if( InterfaceDeviceDetailData == NULL)
    {
        goto CreateUsbDeviceFile_Exit;
    }
    // ĎۂɃC^[tF[X\̂擾
    // ̒DevicePathC܂pXɗp
    InterfaceDeviceDetailData->cbSize = 
        sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
    if( !SetupDiGetDeviceInterfaceDetail(
            DeviceInformationHandle,
            &InterfaceDeviceData, InterfaceDeviceDetailData,
            SizeOfSymbolicName, NULL, NULL) )
    {
        goto CreateUsbDeviceFile_Exit;
    }

    // foCX̃pXL^Ă
    strcpy((CHAR *)DevicePathName,
						InterfaceDeviceDetailData->DevicePath);
    // w肳ꂽt@Cl[ǉ
    strcat ((CHAR *)DevicePathName,"\\");
    strcat ((CHAR *)DevicePathName,filename);

    // C^[tF[X̃pX{t@Cl[
    // foCXhCoCreates
    DeviceHandleWithFileName = CreateFile(
        (CHAR *)DevicePathName,
        GENERIC_WRITE | GENERIC_READ,
        FILE_SHARE_WRITE | FILE_SHARE_READ,
        NULL,OPEN_EXISTING,0,NULL);

    if (DeviceHandleWithFileName == INVALID_HANDLE_VALUE) {
        DeviceHandleWithFileName = NULL;
    }

CreateUsbDeviceFile_Exit:

    // mۂf[^j
    if (InterfaceDeviceDetailData)
        free(InterfaceDeviceDetailData);
    SetupDiDestroyDeviceInfoList(DeviceInformationHandle);

    return DeviceHandleWithFileName;
}

VOID GetConfigurationDescriptor(void)
{
#define OFFSET_USB_INTERFACE_DESCRIPTOR 9
#define OFFSET_USB_INTERFACE_CLASS 5
#define OFFSET_USB_INTERFACE_CLASS_PROTOCOL 7

    ULONG   nBytes;
    UCHAR   buffer[256];
    int     i;

    // RtBM[VfBXNv^iALLjM
    if ( ! DeviceIoControl( hUsbTest,
            IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR,
            NULL,
            0,
            (LPVOID)buffer,
            256, 	//Ƃ肠ő256oCgƂ
                  	//ʏ͂ȉŉ͂ł
            &nBytes,
            NULL
            ) )
    {
        printf("IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR Error! \n");
    }

    // USB̃NXƃvgRĂ
    UsbClass = buffer
                [OFFSET_USB_INTERFACE_DESCRIPTOR
                  + OFFSET_USB_INTERFACE_CLASS];
    UsbProtocol = buffer
                [OFFSET_USB_INTERFACE_DESCRIPTOR
                  + OFFSET_USB_INTERFACE_CLASS_PROTOCOL];

    // Mf[^ƃNXCvgR\
    printf("IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR Success! \n");
    printf("UsbClass=%02x UsbProtocol=%02x \n",UsbClass,UsbProtocol);
    for (i=0; i<(int)nBytes; i++)
        printf("%02x ",buffer[i]);
    printf("\n\n");

}

VOID WdmReadWriteTest(VOID)
{
    UCHAR   buffer[5];
    DWORD   nBytes;
    int i;

    printf("Enter WdmReadWriteTest \n");

    for (i=0; i<5; i++) {
        buffer[i] = 0x30 + i; 	// lASCIIR[h
    }

    // ݃eXg
    if  (! WriteFile(hUsbTest,buffer,5,&nBytes,NULL) ) {
        printf("WriteFile Error \n");
    }
    else {
        printf("WriteFile Success \n");
    }

    // ǂݏoeXg
    if  (! ReadFile(hUsbTest,buffer,5,&nBytes,NULL) ) {
        printf("ReadFile Error \n");
    }
    else {
        // ꍇɃf[^\
        printf("ReadFile Success \n data : ");
        for (i=0; i<5; i++)
         printf("%c",buffer[i]);
        printf("\n");
    }

    printf("Exit WdmReadWriteTest \n");
}

VOID InquiryTest(VOID)
{
    UCHAR atapi[12],buffer[36];
    DWORD nBytes,InquirySize=0;
    int i;

    // ATAPIR}hpPbg(INQUIRY)쐬
    memset(atapi,0,12);
    atapi[0] = 0x12; 	// OP Code/
    atapi[4] = 36;	// Allocate Length

    // ATAPIR}hpPbg𑗐M
    if (!SendAtapiCommandPacket((PUCHAR)atapi,36)) {
        printf("SendAtapiCommandPacket Error \n");
        return;
    }

    // f[^oNINŎ擾
    if  (!ReadFile(hUsbTest,buffer,36,&nBytes,NULL) ) {
        printf("DATA input Error \n");
        return;
    }
    else {
        InquirySize = nBytes; 	// Inquiryf[^TCY̎擾
    }

    // oNI[̏ꍇ́CCSW擾
    if (UsbProtocol == USB_STORAGE_BULK_ONLY_CLASS) {
        if (!BulkOnlyCSWRead()) {
            printf("BulkOnlyCSWRead Error \n");
            return;
        }
    }

    // MINQUIRYf[^\
    printf("Inquiry Data: \n");
    for (i=0; i<(int)nBytes; i++)
        printf("%02x ",buffer[i]);
    printf("\n\n");

    // [JƐi\
    printf("Vendor:");
    for (i=8; i<16; i++) printf("%c",(CHAR)buffer[i]);
    printf("\nProduct:");
    for (i=16; i<32; i++) printf("%c",(CHAR)buffer[i]);
    printf("\n\n");
}

BOOL SendAtapiCommandPacket(PUCHAR atapi,ULONG TransferLength)
{
    BOOL success;
    UCHAR *data=atapi;
    DWORD nBytes;
    int i;

    // MATAPIpPbg\
    printf("SendAtapiCommandPacket:\n ATAPI: ");
    for (i=0; i<12; i++) {
        printf("%02x ",(UCHAR)*data++);
    }
    printf("\n");

    if (UsbProtocol == USB_STORAGE_BULK_ONLY_CLASS) {
        ULONG *DataLength;
        UCHAR buffer[32];

        // oNI[ATAPIpPbg𔭍s
        // CBW쐬đM
        memset(buffer,0,32);

        // dCBWSignature
        buffer[0] = 0x55; buffer[1] = 0x53;
        buffer[2] = 0x42; buffer[3] = 0x43;

        // dCBWTag
        buffer[4] = 0x80; buffer[5] = 0x00;
        buffer[6] = 0x00; buffer[7] = 0x00;

        // dCBWDataTransferLength
        DataLength = (ULONG *)&buffer[8];
        *DataLength = TransferLength;

        // bmCBWFlags
        buffer[12] = 0x80;

        // bCBWCBLength
        buffer[14] = 12; // ATAPIpPbg̒

        // ATAPIpPbgR}hRs[
        memcpy(&buffer[15],atapi,12);

        // CBWoNOUT]
        success = WriteFile(hUsbTest,buffer,31,&nBytes,NULL);
    }
    else {
        // CB/CBIATAPIpPbg𔭍s
        // Rg[]12oCg𑗂
        success = DeviceIoControl(hUsbTest,
            IOCTL_USB_CLASS_REQUEST,
            (LPVOID)atapi,12,NULL,0,&nBytes,NULL);    }
    return success;
}

BOOL BulkOnlyCSWRead(VOID)
{
    UCHAR buffer[16];
    DWORD nBytes;

    // CSWM
    return ReadFile(hUsbTest,buffer,13,&nBytes,NULL);
}

