// usbtest.h
// USBXg[WfoCXeXgpfoCXhCo
// (C) 2003 Kenichiro Hamada

#ifndef _USBTEST_H
#define _USBTEST_H

#ifdef DRIVER

#include <wdm.h>
#include <usbdi.h>
#include <usbdlib.h>
#include <stdio.h>

#if DBG
#define USB_KdPrint(_x_) DbgPrint _x_;
#else
#define USB_KdPrint(_x_)
#endif

//////////////////////////////////////////////////
//             ֐`                         //
//////////////////////////////////////////////////

// ---------- AddDevice ----------

NTSTATUS USB_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    );

// ---------- UnLoad ----------

VOID USB_Unload(IN PDRIVER_OBJECT DriverObject);

// ---------- IRP_MJ_PNP ----------

NTSTATUS USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    );

// ---------- IRP_MJ_POWER ----------

NTSTATUS USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    );

// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

// ---------- IRP_MJ_CLOSE -----------

NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

// ---------- IRP_MJ_DEVICE_CONTROL ----------

NTSTATUS USB_ProcessIOCTL(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

// ---------- IRP_MJ_READ ----------
// ---------- IRP_MJ_WRITE ----------

NTSTATUS USB_BulkReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

#endif      //#ifdef DRIVER

#endif      //#ifndef _USB2TEST_H
