// usbtest.h
// USBXg[WfoCXeXgpfoCXhCo
// (C) 2003 Kenichiro Hamada

#ifndef _USBTEST_H
#define _USBTEST_H

#ifdef DRIVER

#include <wdm.h>
#include <usbdi.h>
#include <usbdlib.h>
#include <stdio.h>
#include <initguid.h> 		 //AddDeviceLqɒǉ

#if DBG
#define USB_KdPrint(_x_) DbgPrint _x_;
#else
#define USB_KdPrint(_x_)
#endif

//////////////////////////////////////////////////
//              \̒`                      //
//////////////////////////////////////////////////

// foCXhCo̊g\

typedef struct _DEVICE_EXTENSION {

    //oXfoCXhCoIuWFNg
    PDEVICE_OBJECT PhysicalDeviceObject;

    // ʂ̃foCXhCoIuWFNg
    PDEVICE_OBJECT StackDeviceObject;

    //AvP[VƂ̃C^[tF[X
    //V{N̖OipXɑj
    UNICODE_STRING InterfaceSymbolicLinkName;

} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

//////////////////////////////////////////////////
//             ֐`                         //
//////////////////////////////////////////////////

// ---------- AddDevice ----------

NTSTATUS USB_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    );

// ---------- UnLoad ----------

VOID USB_Unload(IN PDRIVER_OBJECT DriverObject);

// ---------- IRP_MJ_PNP ----------

NTSTATUS USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    );

NTSTATUS
SendIrpSynchronously (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

NTSTATUS
IrpCompleteEventSet (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    );

// ---------- IRP_MJ_POWER ----------

NTSTATUS USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    );

// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

// ---------- IRP_MJ_CLOSE -----------

NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

// ---------- IRP_MJ_DEVICE_CONTROL ----------

NTSTATUS USB_ProcessIOCTL(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

// ---------- IRP_MJ_READ ----------
// ---------- IRP_MJ_WRITE ----------

NTSTATUS USB_BulkReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

#endif      //#ifdef DRIVER

// {D7FCF225-ACD8-44a5-A0E8-959EE5DE56ED}
DEFINE_GUID(USBTEST_GUID,
	0xd7fcf225, 0xacd8, 0x44a5, 0xa0, 0xe8, 0x95, 0x9e, 0xe5, 0xde, 0x56, 0xed);

#endif      //#ifndef _USB2TEST_H
