// usbtestDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "usbtest.h"
#include "usbtestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUsbtestDlg _CAO

CUsbtestDlg::CUsbtestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUsbtestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUsbtestDlg)
	m_SubClassCode = _T("");
	m_SectorSize = 0;
	m_ProtocolCode = _T("");
	m_ProductName = _T("");
	m_DeviceSpeed = _T("");
	m_ConsoleEditor = _T("");
	m_ClassCode = _T("");
	m_AtapiPacket = _T("");
	m_RequestSenseASCQ = _T("");
	m_RequestSenseASC = _T("");
	m_MaxSector = 0;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUsbtestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUsbtestDlg)
	DDX_Control(pDX, IDC_LIST_DUMP, m_DataDump);
	DDX_Text(pDX, IDC_EDIT_SUBCLASS, m_SubClassCode);
	DDX_Text(pDX, IDC_EDIT_SECTOR_SIZE, m_SectorSize);
	DDX_Text(pDX, IDC_EDIT_PROTOCOL, m_ProtocolCode);
	DDX_Text(pDX, IDC_EDIT_PRODUCT, m_ProductName);
	DDX_Text(pDX, IDC_EDIT_DEVICE_SPEED, m_DeviceSpeed);
	DDX_Text(pDX, IDC_EDIT_CONSOLE, m_ConsoleEditor);
	DDX_Text(pDX, IDC_EDIT_CLASS, m_ClassCode);
	DDX_Text(pDX, IDC_EDIT_ATAPI_PACKET, m_AtapiPacket);
	DDX_Text(pDX, IDC_EDIT_ASCQ, m_RequestSenseASCQ);
	DDX_Text(pDX, IDC_EDIT_ASC, m_RequestSenseASC);
	DDX_Text(pDX, IDC_EDIT_MAX_SECTOR, m_MaxSector);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUsbtestDlg, CDialog)
	//{{AFX_MSG_MAP(CUsbtestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_EXECUTE_TEST, OnButtonExecuteTest)
	ON_BN_CLICKED(IDC_BUTTON_FILE_SELECT, OnButtonFileSelect)
	ON_BN_CLICKED(IDC_BUTTON_REQUEST_SENSE, OnButtonRequestSense)
	ON_BN_CLICKED(IDC_BUTTON_READ_CAPACITY, OnButtonReadCapacity)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUsbtestDlg bZ[W nh

BOOL CUsbtestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CUsbtestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CUsbtestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

#include "UsbStorageDevice.h" 			// Iɒǉ
#include "CBIStorageDevice.h" 			// Iɒǉ
#include "BulkOnlyStorageDevice.h"	// Iɒǉ
void CUsbtestDlg::OnButtonExecuteTest()
{
    // ̈ʒuɃRg[ʒmnhp̃R[hǉ

    // USBXg[WfoCXNX̃eXg

    CUsbDevice *UsbDevice;
    CUsbStorageDevice *UsbStorageDevice;
    USB_DEVICE_CLASS UsbDeviceClass;
    CHAR atapi[12],InquiryData[36],product[16];

    UsbDevice = new CUsbDevice;

    // foCXhCõI[v
    UsbDevice->UsbDeviceDriverOpen();

    // NX擾āC\̐ݒ
    UsbDevice->GetUsbDeviceClass(&UsbDeviceClass);

    // vgRɏ]ăXg[WfoCXI
    if (UsbDeviceClass.InterfaceProtocol != 
					BULK_ONLY_DEVICE_PROTOCOL) {
        UsbStorageDevice =
            (CUsbStorageDevice *)(new CCBIStorageDevice);
    }
    else {
        UsbStorageDevice =
            (CUsbStorageDevice *)(new CBulkOnlyStorageDevice);
    }

    UsbStorageDevice->DeviceInitialize(UsbDevice);

    // InquirypPbgăfoCX֑
    memset(atapi,0,12);
    atapi[0] = 0x12;  // OP Code 
    atapi[4] = 24;    // Allocate Length 
    UsbStorageDevice->SendAtapiRequestPacket((PVOID)atapi,
        36,TRUE);

    // f[^M
    UsbStorageDevice->TransferData(TRUE,36,InquiryData,NULL);

    // Xe[^XM
    UsbStorageDevice->GetStorageDeviceStatus();

    // foCXhCõN[Y
    delete UsbStorageDevice;
    UsbDevice->UsbDeviceDriverClose();
    delete UsbDevice;

    // v_Ng\
    memcpy(product,&InquiryData[16],16);
    m_ProductName = product;

    // 擾Inquiryf[^_vAEg
    DumpData((PCHAR)InquiryData,36);
}

void CUsbtestDlg::OnButtonFileSelect() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
}

void CUsbtestDlg::OnButtonReadCapacity() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
}

void CUsbtestDlg::OnButtonRequestSense() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
}



void CUsbtestDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
}

VOID CUsbtestDlg::ShowMessageToDumpListBox(CHAR *buffer)
{
    // Xg{bNXɎw肳ꂽǉ\

    m_DataDump.AddString(buffer);

    UpdateData(FALSE);

}

VOID CUsbtestDlg::DumpData(CHAR *DataBuffer,ULONG DataLength)
{
#define DUMP_DATA_LOCATE 5
    // sōŏɕ\f[^̉AhXioCgj
#define BYTE_DATA_LENGTH 3
    // 1oCg\ۂ̕

    ULONG DataBufferAddress;
    CHAR showMessageBuffer[512];
    CHAR  *NowPrintDataBuffer = DataBuffer;
    int i;

	// ܂AhXeLXg\
    sprintf(showMessageBuffer,"     00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f");
    ShowMessageToDumpListBox(showMessageBuffer);
    sprintf(showMessageBuffer,"     -----------------------------------------------");
    ShowMessageToDumpListBox(showMessageBuffer);

    // f[^eLXgɂĕ\
    DataBufferAddress=0;
    while (DataBufferAddress < DataLength) {

        // --- 16oCg1sƂčŌ܂ŕ\

        // AhX\/
        sprintf(&showMessageBuffer[0],"%04x ",(USHORT)DataBufferAddress);

        for (i=0; i<16; i++) {

            sprintf(		 // ۂ̃f[^𕶎ɂ
            &showMessageBuffer[DUMP_DATA_LOCATE+i*BYTE_DATA_LENGTH],
                "%02x ",(UCHAR)*NowPrintDataBuffer++
                );
            DataBufferAddress++;
            if (DataBufferAddress >= DataLength) break;
        }
        ShowMessageToDumpListBox(showMessageBuffer);
    }
}

VOID CUsbtestDlg::ClearMessageToDumpListBox(VOID)
{
    int     remainders;

    // Xg{bNX̍ڂOi\ȂjȂΉȂ
    if (!m_DataDump.GetCount()) return;

    while (TRUE) {
        // 擪̕āCc肪OɂȂ܂łJԂ
        remainders = m_DataDump.DeleteString(0);
        if (!remainders) break;
    }

    UpdateData(FALSE);
}

