// UsbDevice.cpp: CUsbDevice NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "usbtest.h"
#include "UsbDevice.h"

// Kvȃwb_t@CCN[h
#include "setupapi.h"
#include "initguid.h"
#include "winioctl.h"

// ̓foCXhCousbtest.sys֘Ȁł
// pX͕M҂̂̂ɂȂĂ̂ŁC[U[Ƃ̊ɍ킹Kv
#include "..\..\sys\usbtest.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CUsbDevice::CUsbDevice()
{

}

CUsbDevice::~CUsbDevice()
{

}

HANDLE CUsbDevice::CreateDeviceFile( GUID* pGuid, ULONG 
					instance,CHAR* filename)
{

    HDEVINFO DeviceInformationHandle;
    SP_INTERFACE_DEVICE_DATA    InterfaceDeviceData;
    PSP_INTERFACE_DEVICE_DETAIL_DATA InterfaceDeviceDetailData;
    DWORD SizeOfSymbolicName;
    HANDLE DeviceHandleWithFileName=NULL;
    UCHAR DevicePathName[512];

    InterfaceDeviceDetailData = NULL;
    memset(&DevicePathName,0,512);

    // GUIDɑΉ񂪂C\HDEVINFO擾
    DeviceInformationHandle =
        SetupDiGetClassDevs(pGuid, NULL, NULL, DIGCF_PRESENT | 
					DIGCF_INTERFACEDEVICE);
    if(DeviceInformationHandle==INVALID_HANDLE_VALUE)
        return NULL;

    // 擾HDEVINFOɑCX^XŎw肵C
    // foCX̃C^[tF[X\̂擾
    // foCXꍇ́CinstanceőIł
    // 1ڂ0ɂȂ
    InterfaceDeviceData.cbSize = sizeof(InterfaceDeviceData);
    if( !SetupDiEnumDeviceInterfaces(
            DeviceInformationHandle,
            NULL, pGuid, instance, &InterfaceDeviceData) )
    {
        goto CreateDeviceFile_Exit;
    }

    // ɏڍׂȃC^[tF[Xf[^擾
    // 킩Ȃ̂ŁC܂͒0Ńf[^擾
    // ̓G[ŉ邪C̎擾ړIȂ̂ŁC
    SetupDiGetDeviceInterfaceDetail(
        DeviceInformationHandle,&InterfaceDeviceData,
        NULL, 0, &SizeOfSymbolicName, NULL);
    // 擾TCYƂɁCC^[tF[X̏ڍ׃f[^mۂ
    InterfaceDeviceDetailData =
        (PSP_INTERFACE_DEVICE_DETAIL_DATA)malloc(SizeOfSymbolicName);
    if( InterfaceDeviceDetailData == NULL)
    {

        goto CreateDeviceFile_Exit;
    }

    // ۂɃC^[tF[X\̂擾
    // ̒DevicePathC܂pXɗp
    InterfaceDeviceDetailData->cbSize = 
					sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
    if( !SetupDiGetDeviceInterfaceDetail(
            DeviceInformationHandle,
            &InterfaceDeviceData, InterfaceDeviceDetailData,
            SizeOfSymbolicName, NULL, NULL) )
    {
        goto CreateDeviceFile_Exit;
    }

    // foCX̃pXL^Ă
    strcpy((CHAR *)DevicePathName,
					InterfaceDeviceDetailData->DevicePath);
    // w肳ꂽt@Cl[ǉ 
    strcat ((CHAR *)DevicePathName,"\\");
    strcat ((CHAR *)DevicePathName,filename);

    // C^[tF[X̃pX{t@Cl[ 
    // foCXhCoCreates
    DeviceHandleWithFileName = CreateFile(
        (CHAR *)DevicePathName,
        GENERIC_WRITE | GENERIC_READ,
        FILE_SHARE_WRITE | FILE_SHARE_READ,
        NULL,OPEN_EXISTING,0,NULL);

    if (DeviceHandleWithFileName == INVALID_HANDLE_VALUE) {
        DeviceHandleWithFileName = NULL;
    }

CreateDeviceFile_Exit:

    // mۂf[^̔j
    if (InterfaceDeviceDetailData)
        free(InterfaceDeviceDetailData);
    SetupDiDestroyDeviceInfoList(DeviceInformationHandle);

    return DeviceHandleWithFileName;

}

BOOL CUsbDevice::UsbDeviceDriverOpen(VOID)
{
    // t@Cl[͓Kł
    CHAR *filename = "usbtest.exe";

    // usbtest.sys̃foCXnh擾
    HandleOfUsbDeviceDriver =
        CreateDeviceFile((LPGUID)&USBTEST_GUID,0,filename);

    if (HandleOfUsbDeviceDriver)
        return TRUE;
    else
        return FALSE;
}

VOID CUsbDevice::UsbDeviceDriverClose(VOID)
{
    // nhN[Y
    CloseHandle(HandleOfUsbDeviceDriver);
}

BOOL CUsbDevice::GetUsbDeviceClass(USB_DEVICE_CLASS *UsbDeviceClass)
{
#define INTERFACE_DESCRIPTOR_OFFSET 9
#define INTERFACE_CLASS_OFFSET      5

    UCHAR   ConfigurationDescriptor[256];
    BOOL    CouldGetConfigurationDescriptor;
    ULONG   TransferCompleteSize;

    // RtBM[VfBXNv^iALLjM
    CouldGetConfigurationDescriptor =
        DeviceIoControl( HandleOfUsbDeviceDriver,
            IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR,
            NULL,
            0,
            (LPVOID)ConfigurationDescriptor,
            256,  // Ƃ肠ő256oCgƂ
                  // ʏ͂ȉŉ͂ł
            &TransferCompleteSize,
            NULL
            );

    // foCX̃NXCTuNXCvgRRs[
    memcpy( UsbDeviceClass,
        &ConfigurationDescriptor[
          INTERFACE_DESCRIPTOR_OFFSET + INTERFACE_CLASS_OFFSET],
        sizeof(USB_DEVICE_CLASS) );

   return CouldGetConfigurationDescriptor;
}

BOOL CUsbDevice::IssueClassRequestPacket
(CHAR *ControlTransferData,ULONG TransferLength)
{
    BOOL    isDeviceIoControlSuccess;
    ULONG   TransferCompleteSize;

    // NXNGXg𔭍s
    isDeviceIoControlSuccess =
        DeviceIoControl(HandleOfUsbDeviceDriver,
            IOCTL_USB_CLASS_REQUEST,
            (LPVOID)ControlTransferData,
            TransferLength,
            NULL,
            0,
            &TransferCompleteSize,
            NULL);

    return isDeviceIoControlSuccess;
}

BOOL CUsbDevice::BulkTransfer
    (BOOL isRead, ULONG transferSize, PVOID transferBuffer,
    ULONG *transferCompleteLength)
{
    BOOL    isBulkTransferSuccess;
    ULONG   dummy;
    ULONG   *getCompleteDataLength;

    // MoCgݒ̏ꍇ́C_~[̒lݒ肷
    if (transferCompleteLength)
        getCompleteDataLength = transferCompleteLength;

    else
        getCompleteDataLength = &dummy;

    // ]ŏU蕪
    if (isRead) {
        isBulkTransferSuccess =
            ReadFile(HandleOfUsbDeviceDriver,
                (LPVOID)transferBuffer,
                transferSize,
                getCompleteDataLength,
                NULL);
    }
    else {
        isBulkTransferSuccess =
            WriteFile(HandleOfUsbDeviceDriver,
                (LPVOID)transferBuffer,
                transferSize,
                getCompleteDataLength,
                NULL);
    }


    if (!isBulkTransferSuccess) {
        // sYGh|CgZbg
        // Gh|Cg̎w̓hCosĂ

        DeviceIoControl(HandleOfUsbDeviceDriver,
            IOCTL_USB_RESET_PIPE,NULL,NULL,NULL,NULL,
            &dummy,NULL);
    }

    return isBulkTransferSuccess;
}

ULONG CUsbDevice::IsDeviceHighSpeed(VOID)
{
    ULONG   IsDeviceHighSpeed=0;
    ULONG   dummy;

    // foCX̑xhCoɊmF
    DeviceIoControl( HandleOfUsbDeviceDriver,
        IOCTL_USB_CHECK_SPEED,
        NULL,
        0,
        (LPVOID)&IsDeviceHighSpeed,
        sizeof(ULONG),
        &dummy,
        NULL
        );

    return IsDeviceHighSpeed; // 0:FS 1:HS 
}

