NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    )
{
    DriverObject->MajorFunction[IRP_MJ_CREATE] = UsbDriverSample_Create;
    DriverObject->MajorFunction[IRP_MJ_CLOSE]  = UsbDriverSample_Close;
    DriverObject->DriverUnload = UsbDriverSample_Unload;

    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] =
                                   UsbDriverSample_ProcessIOCTL;
    DriverObject->MajorFunction[IRP_MJ_WRITE] = UsbDriverSample_ReadWrite;
    DriverObject->MajorFunction[IRP_MJ_READ]  = UsbDriverSample_ReadWrite;
    DriverObject->MajorFunction[IRP_MJ_PNP]   = 

UsbDriverSample_ProcessPnPIrp;
    DriverObject->MajorFunction[IRP_MJ_POWER] = 
UsbDriverSample_ProcessPowerIrp;

    DriverObject->DriverExtension->AddDevice = UsbDriverSample_PnPAddDevice;

    return STATUS_SUCCESS;
}

