// vOvC֐̗
NTSTATUS
UsbDriverSample_ProcessPnPIrp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    PIO_STACK_LOCATION  irpStack, nextStack;
    PDEVICE_EXTENSION   deviceExtension;
    NTSTATUS                    ntStatus;
    BOOLEAN                     DoPassToLowerDeviceDriver = 
					TRUE;

    // ܂I/OX^bNP[Vl
    irpStack = IoGetCurrentIrpStackLocation (Irp);

    deviceExtension = DeviceObject->DeviceExtension;

    //}Ci[t@NVɏU蕪
    switch (irpStack->MinorFunction) {

    case IRP_MN_START_DEVICE:

        // ɉʂ̃foCXhCoɏ
        ntStatus = SendIrpSynchronously(deviceExtension->
					StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // ŃfoCXN̂
            // foCXȂǂ̏Lq
        }


        // ʃhCȍ͏IĂ̂
        // ʂ̃foCXhCo͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        break;

    case IRP_MN_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_REMOVE_DEVICE:

        ntStatus = SendIrpSynchronously(deviceExtension->
							StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // foCX폜ꂽꍇɕKvȏ΁CɋLq
        }

        // foCX폜Ă̂ŁCō쐬foCXIuWFNgȂǁC
        // foCX̃f[^t[ɂ鏈s

        // C^[tF[Xo^Ăꍇ́C폜
        IoSetDeviceInterfaceState(&deviceExtension->
							ifSymLinkName, FALSE);
        RtlFreeUnicodeString(&deviceExtension->ifSymLinkName);

        // ʂ̃foCXhCofoCXIuWFNg
        // ؂藣āCKw\o^폜
        IoDetachDevice(deviceExtension->StackDeviceObject);

        // foCXIuWFNg폜
        IoDeleteDevice (DeviceObject);

        // ʃhCȍ͏IĂ̂ŁCʂ̃foCXhCo͍sȂ

        DoPassToLowerDeviceDriver = FALSE;

        break;

    case IRP_MN_QUERY_REMOVE_DEVICE:
        // Ƃ肠Cł͏sȂ

        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_QUERY_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;

        break;

    case IRP_MN_CANCEL_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_SURPRISE_REMOVAL:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    default:
        // t@NVfoCXhCoȂ̂ŁĈق̃}Ci[R[h
        // T|[gȂŁCʂ̏ɔC
        DoPassToLowerDeviceDriver = TRUE;
        break;

    } 	// switch MinorFunction

    if (DoPassToLowerDeviceDriver) {
        // ̊֐ŏȂꍇׂ͂
        // ʂ̃foCXhCoɂ̂܂ܗ
        // ŏĂ炤`ɂ
        IoSkipCurrentIrpStackLocation (Irp);
        ntStatus = IoCallDriver(deviceExtension->
							StackDeviceObject,Irp);
    }

    return ntStatus;
}

  // ɉʂ̃foCXhCoɏC̏I҂Ƃ
  // sꍇɂ́Cȉ̂悤ȃR[hKvɂȂ

NTSTATUS
SendIrpSynchronously (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    KEVENT   event;
    NTSTATUS status;

    // ʂ̃foCXhCoÎCxg 
    // ҂̂ŁC̃Cxg
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // vOvCȂ̂ŁCI/OX^bN
    // P[Vʂ̃foCXhCoI/OX^bN
    // P[VɃRs[
    IoCopyCurrentIrpStackLocationToNext(Irp);

    // ꍇɌĂяoė~֐o^
    // ̏ꍇ́CSynchronouslyDispatchPnpComplete֐
    // ĂяoāCŃCxgݒ菈s
    IoSetCompletionRoutine(Irp,

                           SynchronouslyDispatchPnpComplete,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʂ̃foCXhCoĂяoāC܂
    // ̃vOvCsĂ炤
    status = IoCallDriver(DeviceObject, Irp);

    // ʂ̃vOvCI܂ő҂
    // ̃CxǵCʂ̃foCXhCo
    // IƁCSynchronouslyDispatchPnpComplete֐
    // ɂĔƂ`ɂȂ
    if (status == STATUS_PENDING) {
        KeWaitForSingleObject(&event,
                             Executive,
                             KernelMode,
                             FALSE,
                             NULL
                             );
        status = Irp->IoStatus.Status;
    }

    return status;
}

  //ʂ̃foCXhCȍIƁC̊֐Ăяo
NTSTATUS
SynchronouslyDispatchPnpComplete (
    IN PDEVICE_OBJECT DeviceObject,

    IN PIRP Irp,
    IN PVOID Context
    )

{
    PKEVENT             event = (PKEVENT)Context;

    // Cxgݒ肵āCCxg҂
    // KeWaitForSingleObject𔲂
    KeSetEvent (event, IO_NO_INCREMENT, FALSE);

    // IĂяȍꍇ́C̃Xe[^XŕԂ
    // ͂u܂ȂvƂoŎg 
    return STATUS_MORE_PROCESSING_REQUIRED;
}
