// IRP_MN_SET_POWERIRP_MN_QUERY_POWER
// ɂirpStack->Parameters̒`

struct {
    ULONG SystemContext;
    POWER_STATE_TYPE POINTER_ALIGNMENT Type;
    POWER_STATE POINTER_ALIGNMENT State;
    POWER_ACTION POINTER_ALIGNMENT ShutdownType;
} Power;

// POINTER_ALIGNMENT32rbgCPUiPentium 4Ȃǁjł͖`
#if defined(_WIN64)
#define POINTER_ALIGNMENT DECLSPEC_ALIGN(8)
#else
#define POINTER_ALIGNMENT
#endif

typedef enum _POWER_STATE_TYPE {
    SystemPowerState = 0,
    DevicePowerState
} POWER_STATE_TYPE, *PPOWER_STATE_TYPE;

typedef union _POWER_STATE {
    SYSTEM_POWER_STATE SystemState; //éCXg1-15Q
    DEVICE_POWER_STATE DeviceState; //éCXg1-15Q
} POWER_STATE, *PPOWER_STATE;

typedef enum {
    PowerActionNone = 0,
    PowerActionReserved,
    PowerActionSleep,
    PowerActionHibernate,
    PowerActionShutdown,
    PowerActionShutdownReset,
    PowerActionShutdownOff,
    PowerActionWarmEject
} POWER_ACTION, *PPOWER_ACTION;
