// I/O Request Packet(IRP)`

typedef struct _IRP {
    CSHORT Type;

    USHORT Size;

    // IRPRg[邽߂ɎgCʂ̃tB[h`

    // I/ONGXĝ߂ɁC|C^MDLɒ`
    // ̃tB[h̓_CNgI/Ô݂Ŏg

    PMDL MdlAddress;

    // ܂܂ȃtOi[hj

    ULONG Flags;

    // uniońCȉ3̏ꍇ̂1ɂĂ͂܂ƂɎg
    // @IRPꂽIRPłꍇD̏ꍇC̃tB[h̓}X^[
    //   IRPւ̃|C^ł
    // AAssociatedIrp̓}X^[IRPłC̃tB[h}X^[I
    //   OɊȂƂȂꂽIRP̃JE^łꍇ
    // B̃Iy[Vobt@OāC̃tB[hC
    //   VXeXy[Xobt@̃AhXłꍇ

    union {
        struct _IRP *MasterIrp;
        LONG IrpCount;
        PVOID SystemBuffer;
    } AssociatedIrp;

    // Thread list entry - XbhŃyfBOꂽI/O
    // NGXgpPbgXg̃L[COĂ


    LIST_ENTRY ThreadListEntry;

    // I/O status - Iy[VĨXe[^X

    IO_STATUS_BLOCK IoStatus;

    // Requestor mode - ̃Iy[VvIWĩ[h

    KPROCESSOR_MODE RequestorMode;

    // Pending returned - C̃pPbg̃Xe[^XƂ
    // PENDINGŏɖ߂ȂTRUEɂȂ

    BOOLEAN PendingReturned;

    // X^bNԂ̏

    CHAR StackCount;
    CHAR CurrentLocation;

    // Cancel - pPbgLZꂽ

    BOOLEAN Cancel;

    // Cancel Irql - LZXsbN𓾂Irql


    KIRQL CancelIrql;

    // ApcEnvironment - pPbgꂽƂAPC̊
    // Z[ûɎgp

    CCHAR ApcEnvironment;

    // AP[ṼRg[tO

    UCHAR AllocationFlags;

    // [U[̃p[^

    PIO_STATUS_BLOCK UserIosb;
    PKEVENT UserEvent;
    union {
        struct {
            PIO_APC_ROUTINE UserApcRoutine;
            PVOID UserApcContext;
        } AsynchronousParameters;
        LARGE_INTEGER AllocationSize;
    } Overlay;

    // CancelRoutine - IRPLZ̏ԂɂȂƂɃfoCXhCo
    // LZ[`̃AhX܂񂾂

    PDRIVER_CANCEL CancelRoutine;

    // ǂ̃T[rXv𐳊mɒmȂĂ
    // 悢[U[AhXԂI/Of[^Rs[ł
    // 悤ɁCUserBufferp[^̓X^bN̊OɂDRs[̒́C
    // I/OStatus Blocǩ㔼ɒ~UserBuffertB[h
    // NULLłȂ΁CRs[͍sȂ

    PVOID UserBuffer;

    // J[l\
    //
    // ̃ZNV́CJ[l\(e탏[NCtH[V
    // J[lRg[VXẽL[ɒu߁CIRP
    // KvƂ)܂ރTCYCсC񂪃Rg[邱Ƃ
    // łȂ̂ŁC͂ɒuDāC
    // ɂ͎GꂸCIRPłق̃tB[h̐
    // eyڂƂȂ

    union {

        struct {

            union {

                // DeviceQueueEntry - foCXL[Gg
                // tB[h́CIRPfoCXhCo
                // foCXL[ɃL[CÔɎg

                KDEVICE_QUEUE_ENTRY DeviceQueueEntry;

                struct {

                    // hCopPbgLĂԁCǂȕ@
                    // ł낤ƂL̃tB[h𗘗pł

                    PVOID DriverContext[4];

                } ;

            } ;

            // Thread - ĂяõXbhRg[
            // ubNւ̃|C^

            PETHREAD Thread;

            // Auxiliary buffer - hCo֏n̂ɕKvƂ
            // ⏕̃obt@ւ̃|C^́Cȃobt@Ɋ܂܂Ȃ

            PCHAR AuxiliaryBuffer;

            // ̍\́C~jpPbgwb_gL[ւ
            // Gĝ߂Ɏg\̂ƓłȂ΂ȂȂ

            struct {

              // List entry - ق̊pPbgL[L[CO
              // ̂Ɏg

                LIST_ENTRY ListEntry;

                union {

                // Current stack location - IRP X^bNɂ
                // ݂IO_STACK_LOCATIOÑ|C^܂
                // ̃tB[h́ChCoɂĒڃANZXׂł
                // ȂCW֐gׂ

                struct _IO_STACK_LOCATION 
										*CurrentStackLocation;

                 // ~jpPbg^Cv

                    ULONG PacketType;
                };
            };

            // Original file object -t@CJ߂Ɏgꂽ
            // IWĩt@CIuWFNgւ̃|C^
            // ̃tB[h́CI/OVXeɂďLC
            // ق̃hCoɂĎgׂłȂ

            PFILE_OBJECT OriginalFileObject;

        } Overlay;


        // APC - 1IWïXgɂĎw肳ꂽȂ΁C
        // APCRg[ubŃCĂяo
        // lɁCʂȃJ[lAPĈ߂ɎgDāCAPC
        // IRPPɃfBAP[g鐧𓾂OɁuʂȁv
        // [`ɗv悤ƁC邢͌Ăяoǂ̂悤
        // [hł낤ƁCʏAPCƂčėp

        KAPC Apc;

        // CompletionKey - ́C1̃t@CnhŊJnꂽ
        // XI/O Iy[Vʂ邽߂ɎgL[ł

        PVOID CompletionKey;

    } Tail;

} IRP, *PIRP;
