NTSTATUS USB_ClassRequest(
    PDEVICE_OBJECT DeviceObject,
    PCHAR   pBuffer,
    PULONG length
    )
{
    NTSTATUS        ntStatus;
    URB             urb;

    // NXNGXgsURB쐬
    UsbBuildVendorRequest(  &urb, URB_FUNCTION_CLASS_INTERFACE,
        (USHORT)sizeof(struct 
							_URB_CONTROL_VENDOR_OR_CLASS_REQUEST),
        0,		// ULONG    transferFlags
        0,		// UCHAR    reservedbits
        0,		// UCHAR    request
        0,		// USHORT   value
        0,		// USHORT   index
        pBuffer,		// IN PVOID TransferBuffer
        NULL,		// IN PMDL TransferBufferMDL
        *length,		// IN ULONG TransferBufferLength,
        NULL );		// IN PURB Link )

    // NXNGXg𔭍sāC]f[^ݒ肷
    ntStatus = USB_CallUSBD(DeviceObject, &urb);
    if (NT_SUCCESS(ntStatus)) {
        *length = urb.UrbControlVendorClassRequest.
							TransferBufferLength;
    } else {
        *length = 0;
    }

    USB_KdPrint (("USB_ClassRequest urb.status %x\n", 
				urb.UrbHeader.Status));

    return(urb.UrbHeader.Status);
}
