VOID InquiryTest(VOID)
{
    UCHAR atapi[12],buffer[36];
    DWORD nBytes,InquirySize=0;
    int i;

    // ATAPIR}hpPbg(INQUIRY)쐬
    memset(atapi,0,12);
    atapi[0] = 0x12; 	// OP Code/
    atapi[4] = 36;	// Allocate Length

    // ATAPIR}hpPbg𑗐M
    if (!SendAtapiCommandPacket((PUCHAR)atapi,36)) {
        printf("SendAtapiCommandPacket Error \n");
        return;
    }

    // f[^oNINŎ擾
    if  (!ReadFile(hUsbTest,buffer,36,&nBytes,NULL) ) {
        printf("DATA input Error \n");
        return;
    }
    else {
        InquirySize = nBytes; 	// Inquiryf[^TCY̎擾
    }

    // oNI[̏ꍇ́CCSW擾
    if (UsbProtocol == USB_STORAGE_BULK_ONLY_CLASS) {
        if (!BulkOnlyCSWRead()) {
            printf("BulkOnlyCSWRead Error \n");
            return;
        }
    }

    // MINQUIRYf[^\
    printf("Inquiry Data: \n");
    for (i=0; i<(int)nBytes; i++)
        printf("%02x ",buffer[i]);
    printf("\n\n");

    // [JƐi\
    printf("Vendor:");
    for (i=8; i<16; i++) printf("%c",(CHAR)buffer[i]);
    printf("\nProduct:");
    for (i=16; i<32; i++) printf("%c",(CHAR)buffer[i]);
    printf("\n\n");
}

BOOL SendAtapiCommandPacket(PUCHAR atapi,ULONG TransferLength)
{
    BOOL success;
    UCHAR *data=atapi;
    DWORD nBytes;
    int i;

    // MATAPIpPbg\
    printf("SendAtapiCommandPacket:\n ATAPI: ");
    for (i=0; i<12; i++) {
        printf("%02x ",(UCHAR)*data++);
    }
    printf("\n");

    if (UsbProtocol == USB_STORAGE_BULK_ONLY_CLASS) {
        ULONG *DataLength;
        UCHAR buffer[32];

        // oNI[ATAPIpPbg𔭍s
        // CBW쐬đM
        memset(buffer,0,32);

        // dCBWSignature
        buffer[0] = 0x55; buffer[1] = 0x53;
        buffer[2] = 0x42; buffer[3] = 0x43;

        // dCBWTag
        buffer[4] = 0x80; buffer[5] = 0x00;
        buffer[6] = 0x00; buffer[7] = 0x00;

        // dCBWDataTransferLength
        DataLength = (ULONG *)&buffer[8];
        *DataLength = TransferLength;

        // bmCBWFlags
        buffer[12] = 0x80;

        // bCBWCBLength
        buffer[14] = 12; // ATAPIpPbg̒

        // ATAPIpPbgR}hRs[
        memcpy(&buffer[15],atapi,12);

        // CBWoNOUT]
        success = WriteFile(hUsbTest,buffer,31,&nBytes,NULL);
    }
    else {
        // CB/CBIATAPIpPbg𔭍s
        // Rg[]12oCg𑗂
        success = DeviceIoControl(hUsbTest,
            IOCTL_USB_CLASS_REQUEST,
            (LPVOID)atapi,12,NULL,0,&nBytes,NULL);    }
    return success;
}

BOOL BulkOnlyCSWRead(VOID)
{
    UCHAR buffer[16];
    DWORD nBytes;

    // CSWM
    return ReadFile(hUsbTest,buffer,13,&nBytes,NULL);
}
