HANDLE CUsbDevice::CreateDeviceFile( GUID* pGuid, ULONG 
					instance,CHAR* filename)
{

    HDEVINFO DeviceInformationHandle;
    SP_INTERFACE_DEVICE_DATA    InterfaceDeviceData;
    PSP_INTERFACE_DEVICE_DETAIL_DATA InterfaceDeviceDetailData;
    DWORD SizeOfSymbolicName;
    HANDLE DeviceHandleWithFileName=NULL;
    UCHAR DevicePathName[512];

    InterfaceDeviceDetailData = NULL;
    memset(&DevicePathName,0,512);

    // GUIDɑΉ񂪂C\HDEVINFO擾
    DeviceInformationHandle =
        SetupDiGetClassDevs(pGuid, NULL, NULL, DIGCF_PRESENT | 
					DIGCF_INTERFACEDEVICE);
    if(DeviceInformationHandle==INVALID_HANDLE_VALUE)
        return NULL;

    // 擾HDEVINFOɑCX^XŎw肵C
    // foCX̃C^[tF[X\̂擾
    // foCXꍇ́CinstanceőIł
    // 1ڂ0ɂȂ
    InterfaceDeviceData.cbSize = sizeof(InterfaceDeviceData);
    if( !SetupDiEnumDeviceInterfaces(
            DeviceInformationHandle,
            NULL, pGuid, instance, &InterfaceDeviceData) )
    {
        goto CreateDeviceFile_Exit;
    }

    // ɏڍׂȃC^[tF[Xf[^擾
    // 킩Ȃ̂ŁC܂͒0Ńf[^擾
    // ̓G[ŉ邪C̎擾ړIȂ̂ŁC
    SetupDiGetDeviceInterfaceDetail(
        DeviceInformationHandle,&InterfaceDeviceData,
        NULL, 0, &SizeOfSymbolicName, NULL);
    // 擾TCYƂɁCC^[tF[X̏ڍ׃f[^mۂ
    InterfaceDeviceDetailData =
        (PSP_INTERFACE_DEVICE_DETAIL_DATA)malloc(SizeOfSymbolicName);
    if( InterfaceDeviceDetailData == NULL)
    {

        goto CreateDeviceFile_Exit;
    }

    // ۂɃC^[tF[X\̂擾
    // ̒DevicePathC܂pXɗp
    InterfaceDeviceDetailData->cbSize = 
					sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
    if( !SetupDiGetDeviceInterfaceDetail(
            DeviceInformationHandle,
            &InterfaceDeviceData, InterfaceDeviceDetailData,
            SizeOfSymbolicName, NULL, NULL) )
    {
        goto CreateDeviceFile_Exit;
    }

    // foCX̃pXL^Ă
    strcpy((CHAR *)DevicePathName,
					InterfaceDeviceDetailData->DevicePath);
    // w肳ꂽt@Cl[ǉ 
    strcat ((CHAR *)DevicePathName,"\\");
    strcat ((CHAR *)DevicePathName,filename);

    // C^[tF[X̃pX{t@Cl[ 
    // foCXhCoCreates
    DeviceHandleWithFileName = CreateFile(
        (CHAR *)DevicePathName,
        GENERIC_WRITE | GENERIC_READ,
        FILE_SHARE_WRITE | FILE_SHARE_READ,
        NULL,OPEN_EXISTING,0,NULL);

    if (DeviceHandleWithFileName == INVALID_HANDLE_VALUE) {
        DeviceHandleWithFileName = NULL;
    }

CreateDeviceFile_Exit:

    // mۂf[^̔j
    if (InterfaceDeviceDetailData)
        free(InterfaceDeviceDetailData);
    SetupDiDestroyDeviceInfoList(DeviceInformationHandle);

    return DeviceHandleWithFileName;

}
