struct USB_COMPLETION_INFO
{
    PURB m_pUrb;
    BulkUsbDevice* m_pClass;
};

NTSTATUS BulkUsbDevice::Read(KIrp I)
{
    t << "Entering BulkUsbDevice::Read, " << I << EOL;
// TODOFNGXg`FbNDNGXgȏꍇTRUE
//       ԂȂCȉ̍śuFALSEv`FbNu

    if (FALSE)      // If(NGXg͖ł)
    {
        // ReadNGXg̖ȃp[^
        I.Information() = 0;
        return I.PnpComplete(this, STATUS_INVALID_PARAMETER);
    }

    // 0oCgǂݍނȂCOKԂ
    if (I.ReadSize() == 0)
    {
        I.Information() = 0;
        return I.PnpComplete(this, STATUS_SUCCESS);

    }

   // IuWFNg錾
    KMemory Mem(I.Mdl());

    ULONG dwTotalSize = I.ReadSize(CURRENT);
    ULONG dwMaxSize = m_BulkInEndpoint MaximumTransferSize();

    // NGXgꂽǂݎ̑TCYpCvMaximum Transfer Size
    // 傫ꍇCoXfoCXhCoMaximum Transfer Size
    // 傫
    // TransferBufferLengthURBɎŝŁCMaximum Transfer 
    // SizeNGXg
    if (dwTotalSize > dwMaxSize)
    {
        ASSERT(dwMaxSize);
        dwTotalSize = dwMaxSize;
    }

    // Irpp̐VKReLXg\̂AP[g
    USB_COMPLETION_INFO* pCompInfo = new (NonPagedPool) 
							USB_COMPLETION_INFO;
    if (pCompInfo == NULL)
    {
        I.Information() = 0;
        return I.PnpComplete(this, 
							STATUS_INSUFFICIENT_RESOURCES);
    }

// TODOFǂݎ邽߂̐pCvI

    // pCvۂBulk[h邽߂URB쐬
    PURB pUrb = m_BulkInEndpoint.BuildBulkTransfer(
                    Mem,            // obt@AhX
                    dwTotalSize,    // ǂݎf[^
                    TRUE,           // ](TRUE = IN)
                    NULL,           // URBւ̃N
                    TRUE            // V[gpPbg]
                    );

    if (pUrb == NULL)
    {
        delete pCompInfo;
        I.Information() = 0;
        return I.PnpComplete(this, 
							STATUS_INSUFFICIENT_RESOURCES);
    }

    // ReLXg\̂
    pCompInfo->m_pClass = this;
    pCompInfo->m_pUrb = pUrb;

   // USBfoCXURBs
    NTSTATUS status;
    status = m_BulkInEndpoint.SubmitUrb(I, pUrb, 
							LinkTo(ReadComplete), _
					pCompInfo, 0);
    return status;

}

NTSTATUS BulkUsbDevice::ReadComplete(KIrp I, 
USB_COMPLETION_INFO* pContext)

{
    // yfBOtOpʏ̊[`R[h

    if (I->PendingReturned)
    {
        I.MarkPending();
    }

    NTSTATUS status = I.Status();
    PURB pUrb = pContext->m_pUrb;
    ULONG nBytesRead = 0;

    if ( NT_SUCCESS(status) )
    {
        nBytesRead = pUrb->
					UrbBulkOrInterruptTransfer.TransferBufferLength;
        if (nBytesRead > 0)
            t << "Read() got "
							 << nBytesRead<< " bytes from USB\n";
    }


    // UrbƃReLXg\̂
    delete pUrb;
    delete pContext;

   // Ԃꂽf[^ݒ肷
    I.Information() = nBytesRead;

   // vOAhvC̓vXV
    DecrementOutstandingRequestCount();

   // IRPI
    return STATUS_SUCCESS;
}
