/////////////////////////////////////////////////////////////
// KUsbLowerDevice::GetBusInterface
//
// oXC^[tF[X\̂mۂ
//
//

#define WDM_MAJOR_VERSION 1
#define WINDOWS_XP_FUNCTION_SUPPORT_VALUE 0x20

VOID KUsbLowerDevice::GetBusInterface(VOID)
{
    NTSTATUS                   ntStatus=STATUS_SUCCESS;
    PIO_STACK_LOCATION         nextStack;
    ULONG                      isWindowsXPSupport;

    m_UsbBusInterface.Size = 0; // G[͂̈ɂ

    // OSWindows XPȍ~ǂ𒲂ׂ
    isWindowsXPSupport =
        IoIsWdmVersionAvailable(
            WDM_MAJOR_VERSION,
            WINDOWS_XP_FUNCTION_SUPPORT_VALUE);
    if (!isWindowsXPSupport) {
        return;
    }

    // USBoXCtH[V擾pIRPmۂ
    KIrp I = KIrp::Allocate(StackRequirement());

    // IRPIʒm̃Cxg쐬
    KEvent event(NotificationEvent, FALSE);

    // IRPoXfoCXhCo
    // USB_DispatchPnpCompleteĂ
    // Cxgݒ肵Ă炤
    I.SetCompletionRoutine(GetBusInterfaceComplete,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʃhCoI/OX^bNP[Vmۂď

    nextStack = I.NextStackLocation();
    ASSERT(nextStack);
    nextStack->MajorFunction = IRP_MJ_PNP;
    nextStack->MinorFunction = IRP_MN_QUERY_INTERFACE;

    // oXC^[tF[X̃|C^
    nextStack->Parameters.QueryInterface.Interface =
        (PINTERFACE) &m_UsbBusInterface;

    // C^[tF[Xdlf[^͂Ȃ
    nextStack->Parameters.QueryInterface.InterfaceSpecificData 
							= NULL;

    // USBDoXhCoGUIDݒ肷
    nextStack->Parameters.QueryInterface.InterfaceType =
                            &USB_BUS_INTERFACE_USBDI_GUID;

    // oXC^[tF[X̃TCYݒ肷
    nextStack->Parameters.QueryInterface.Size =
                        sizeof(USB_BUS_INTERFACE_USBDI_V1);

    // oXC^[tF[X̃o[WPw肷
    nextStack->Parameters.QueryInterface.Version = 
							USB_BUSIF_USBDI_VERSION_1;

    // ʂ̃oXfoCXhCoɏ˗ďI҂

    ntStatus = Call(I);
    if(STATUS_PENDING == ntStatus) {
        event.Wait(KernelMode, FALSE, NULL);
        ntStatus = I.Status();
    }

    I.Deallocate(I.m_Irp);
}


/////////////////////////////////////////////////////////////
// KUsbLowerDevice::GetBusInterface
//
// oXC^[tF[X\̂̎擾
//
//
NTSTATUS KUsbLowerDevice::GetBusInterfaceComplete(
    PDEVICE_OBJECT  DeviceObject,
    PIRP            pIrp,
    PVOID           Context
    )
{
    KEvent *event = (KEvent *)Context;

    // Cxgݒ肵Ĕ
    event->Set(IO_NO_INCREMENT,FALSE);

    return STATUS_MORE_PROCESSING_REQUIRED;
}
/////////////////////////////////////////////////////////////
// KUsbLowerDevice::GetBusInterface
//
// oXC^[tF[X\̂n
//
//
PUSB_BUS_INTERFACE_USBDI_V1 
					KUsbLowerDevice::GetBusInterfaceStructure(VOID)
{
    if (!m_UsbBusInterface.Size)
        return NULL;  // oXC^[tF[X\̂̎擾Ɏs

    return (PUSB_BUS_INTERFACE_USBDI_V1)
							&m_UsbBusInterface.Size;
}
