NTSTATUS UsbtestDevice::IOCTL_USB_CHECK_SPEED_Handler(KIrp I)
{
    NTSTATUS status = STATUS_SUCCESS;
    USB_BUS_INTERFACE_USBDI_V1 *UsbBusInterface;

    t << "Entering UsbtestDevice::IOCTL_USB_CHECK_SPEED_Handler," << I << "\n" << EOL;

    // oXC^[tF[X\̂擾
    UsbBusInterface = m_Lower.GetBusInterfaceStructure();

    if (UsbBusInterface)
    {
        // USBoXCtH[VIsDeviceHighSpeed
        // gāCUSB2.0foCXۂmF

        ULONG *IsDeviceHighSpeed = (ULONG *)I.IoctlBuffer();

        *IsDeviceHighSpeed =
                UsbBusInterface->IsDeviceHighSpeed(
                    UsbBusInterface->BusContext);


        t << "IsDeviceHighSpeed = " << *IsDeviceHighSpeed << "\n" << EOL;

        status = STATUS_SUCCESS;
        I.Information() = sizeof(ULONG);
    }
    else {
        // T|[gȂꍇ̓G[ɂ
        status = STATUS_NOT_SUPPORTED;
        I.Information() = 0;
        t << "This IOCTL funciton not supported! \n";
    }

    I.Status() = status;
    return status;
}

