// WindowsŃhCo𐧌䂷ꍇ͂ 
// t@CCN[hKv
#include "windows.h"
#include "setupapi.h"
#include "stdio.h"
#include "initguid.h"
#include "winioctl.h"

// ̓foCXhCousbtest.sys֘Ȁł
// pX͕M҂̂̂ɂȂĂ̂ŁC̊ɍ킹Kv
#include "..\..\sys\usbtest.h"

#define DEVICE_PATH_NAME_LENGTH 1024

// RtBO[VfBXNv^֘A̒`
#define USB_CLASS_MASS_STORAGE 8
#define USB_STORAGE_BULK_ONLY_CLASS 0x50

// ֐̒`
HANDLE CreateDeviceFile(GUID *pGuid, ULONG instance,CHAR* filename);
VOID GetConfigurationDescriptor(VOID);
VOID WdmReadWriteTest(VOID);

// O[oϐ
HANDLE hUsbTest;
UCHAR UsbClass;
UCHAR UsbProtocol;

int main(int argc, char* argv[])
{
    CHAR *filename = "usbtest";
    char key;

    printf("UsbDosTest Main \n");

    // foCXhCousbtest.sys̃I[v
    hUsbTest = CreateDeviceFile(
        (LPGUID)&USBTEST_GUID,0,filename);
    if (!hUsbTest) {
        printf("CreateDeviceFile error ! \n");
        goto Main_End;
    }

    printf("CreateDeviceFile Success! \n");

    // RtBM[VfBXNv^擾
    GetConfigurationDescriptor();

    // [h/Cg̃eXg
    WdmReadWriteTest();

    // foCXhCõN[Y 
    CloseHandle(hUsbTest);

Main_End:
    scanf("%c",&key); 		// ɏIȂ悤ɓ͑҂

    return 0;
}

HANDLE CreateDeviceFile(GUID *pGuid, ULONG instance,
					CHAR* filename)
{
    HDEVINFO DeviceInformationHandle;
    SP_INTERFACE_DEVICE_DATA    InterfaceDeviceData;
    PSP_INTERFACE_DEVICE_DETAIL_DATA InterfaceDeviceDetailData;
    DWORD SizeOfSymbolicName;
    HANDLE DeviceHandleWithFileName=NULL;
    UCHAR DevicePathName[DEVICE_PATH_NAME_LENGTH];

    InterfaceDeviceDetailData = NULL;
    memset(&DevicePathName,0,DEVICE_PATH_NAME_LENGTH);

    // GUIDɑΉ񂪂\HDEVINFO擾
    DeviceInformationHandle =
        SetupDiGetClassDevs(pGuid, NULL, NULL, DIGCF_PRESENT | 
DIGCF_INTERFACEDEVICE);
    if(DeviceInformationHandle==INVALID_HANDLE_VALUE)
        return NULL;

    // 擾HDEVINFOɑCX^XŎw肵
    // foCX̃C^[tF[X\̂擾
    // ̓foCXꍇ́CinstanceőIł
    // Pڂ0ɂȂ
    InterfaceDeviceData.cbSize = sizeof(InterfaceDeviceData);
    if( !SetupDiEnumDeviceInterfaces(
            DeviceInformationHandle,
            NULL, pGuid, instance, &InterfaceDeviceData) )
    {
        goto CreateUsbDeviceFile_Exit;
    }

    // ɏڍׂȃC^[tF[Xf[^擾
    // 킩Ȃ̂ŁC܂͒0Ŏ擾
    // ̓G[ŉ邪C̎擾ړIȂ̂Ŗ
    SetupDiGetDeviceInterfaceDetail(
        DeviceInformationHandle,&InterfaceDeviceData,
        NULL, 0, &SizeOfSymbolicName, NULL);

    // 擾TCYƂɁCC^[tF[X̏ڍׂȃf[^mۂ
    InterfaceDeviceDetailData =
            (PSP_INTERFACE_DEVICE_DETAIL_DATA)
								malloc(SizeOfSymbolicName);
    if( InterfaceDeviceDetailData == NULL)
    {
        goto CreateUsbDeviceFile_Exit;
    }
    // ĎۂɃC^[tF[X\̂擾
    // ̒DevicePathC܂pXɗp
    InterfaceDeviceDetailData->cbSize = 
        sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
    if( !SetupDiGetDeviceInterfaceDetail(
            DeviceInformationHandle,
            &InterfaceDeviceData, InterfaceDeviceDetailData,
            SizeOfSymbolicName, NULL, NULL) )
    {
        goto CreateUsbDeviceFile_Exit;
    }

    // foCX̃pXL^Ă
    strcpy((CHAR *)DevicePathName,
						InterfaceDeviceDetailData->DevicePath);
    // w肳ꂽt@Cl[ǉ
    strcat ((CHAR *)DevicePathName,"\\");
    strcat ((CHAR *)DevicePathName,filename);

    // C^[tF[X̃pX{t@Cl[
    // foCXhCoCreates
    DeviceHandleWithFileName = CreateFile(
        (CHAR *)DevicePathName,
        GENERIC_WRITE | GENERIC_READ,
        FILE_SHARE_WRITE | FILE_SHARE_READ,
        NULL,OPEN_EXISTING,0,NULL);

    if (DeviceHandleWithFileName == INVALID_HANDLE_VALUE) {
        DeviceHandleWithFileName = NULL;
    }

CreateUsbDeviceFile_Exit:

    // mۂf[^j
    if (InterfaceDeviceDetailData)
        free(InterfaceDeviceDetailData);
    SetupDiDestroyDeviceInfoList(DeviceInformationHandle);

    return DeviceHandleWithFileName;
}

VOID GetConfigurationDescriptor(void)
{
#define OFFSET_USB_INTERFACE_DESCRIPTOR 9
#define OFFSET_USB_INTERFACE_CLASS 5
#define OFFSET_USB_INTERFACE_CLASS_PROTOCOL 7

    ULONG   nBytes;
    UCHAR   buffer[256];
    int     i;

    // RtBM[VfBXNv^iALLjM
    if ( ! DeviceIoControl( hUsbTest,
            IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR,
            NULL,
            0,
            (LPVOID)buffer,
            256, 	//Ƃ肠ő256oCgƂ
                  	//ʏ͂ȉŉ͂ł
            &nBytes,
            NULL
            ) )
    {
        printf("IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR Error! \n");
    }

    // USB̃NXƃvgRĂ
    UsbClass = buffer
                [OFFSET_USB_INTERFACE_DESCRIPTOR
                  + OFFSET_USB_INTERFACE_CLASS];
    UsbProtocol = buffer
                [OFFSET_USB_INTERFACE_DESCRIPTOR
                  + OFFSET_USB_INTERFACE_CLASS_PROTOCOL];

    // Mf[^ƃNXCvgR\
    printf("IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR Success! \n");
    printf("UsbClass=%02x UsbProtocol=%02x \n",UsbClass,UsbProtocol);
    for (i=0; i<(int)nBytes; i++)
        printf("%02x ",buffer[i]);
    printf("\n\n");

}

VOID WdmReadWriteTest(VOID)
{
    UCHAR   buffer[5];
    DWORD   nBytes;
    int i;

    printf("Enter WdmReadWriteTest \n");

    for (i=0; i<5; i++) {
        buffer[i] = 0x30 + i; 	// lASCIIR[h
    }

    // ݃eXg
    if  (! WriteFile(hUsbTest,buffer,5,&nBytes,NULL) ) {
        printf("WriteFile Error \n");
    }
    else {
        printf("WriteFile Success \n");
    }

    // ǂݏoeXg
    if  (! ReadFile(hUsbTest,buffer,5,&nBytes,NULL) ) {
        printf("ReadFile Error \n");
    }
    else {
        // ꍇɃf[^\
        printf("ReadFile Success \n data : ");
        for (i=0; i<5; i++)
         printf("%c",buffer[i]);
        printf("\n");
    }

    printf("Exit WdmReadWriteTest \n");
}
