// usbtest.c
// USBXg[WfoCXeXgpfoCXhCo
// (C) 2003 Kenichiro Hamada

#define DRIVER

#include "usbtest.h"

// ---------- DriverEntry ----------

NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    )
{

    USB_KdPrint (("Hello World I'm DriverEntry \n"));

    // e̊֐o^
    DriverObject->DriverExtension->AddDevice			= USB_PnPAddDevice;
    DriverObject->DriverUnload								= USB_Unload;
    DriverObject->MajorFunction[IRP_MJ_PNP]				= USB_DispatchPnp;
    DriverObject->MajorFunction[IRP_MJ_POWER]			= USB_DispatchPower;
    DriverObject->MajorFunction[IRP_MJ_CREATE]			= USB_Create;
    DriverObject->MajorFunction[IRP_MJ_CLOSE]			= USB_Close;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL]	= USB_ProcessIOCTL;
    DriverObject->MajorFunction[IRP_MJ_READ]			= USB_BulkReadWrite;	
    DriverObject->MajorFunction[IRP_MJ_WRITE]			= USB_BulkReadWrite;

    return STATUS_SUCCESS;
}

// ---------- AddDevice ----------

NTSTATUS
USB_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    )
{
    USB_KdPrint (("Hello World I'm USB_PnPAddDevice \n"));

    return STATUS_UNSUCCESSFUL;
}

// ---------- UnLoad ----------

VOID USB_Unload(IN PDRIVER_OBJECT DriverObject)
{
    USB_KdPrint (("Hello World I'm USB_Unload \n"));
}

// ---------- IRP_MJ_PNP ----------

NTSTATUS
USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_DispatchPnp \n"));

    return STATUS_UNSUCCESSFUL;
}

// ---------- IRP_MJ_POWER ----------

NTSTATUS
USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_DispatchPower \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Create \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_CLOSE ----------

NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Close \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_DEVICE_CONTROL ---------

NTSTATUS USB_ProcessIOCTL(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_ProcessIOCTL \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_READ -----------
// ---------- IRP_MJ_WRITE ----------

NTSTATUS USB_BulkReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_BulkReadWrite \n"));

    return STATUS_UNSUCCESSFUL;
}

// EOF
