// UsbDevice.h: CUsbDevice NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_USBDEVICE_H__76F02E71_1080_4373_97F9_D6AED0ABB9A4__INCLUDED_)
#define AFX_USBDEVICE_H__76F02E71_1080_4373_97F9_D6AED0ABB9A4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <PSHPACK1.H>       //\̂pbN

// C^[tF[XfBXNv^̒`
typedef struct {
    UCHAR   iLength;
    UCHAR   iDescriptorType;
    UCHAR   InterfaceNumber;
    UCHAR   AlternateSetting;
    UCHAR   NumEndpoints;
    UCHAR   InterfaceClass;
    UCHAR   InterfaceSubClass;
    UCHAR   InterfaceProtocol;
    UCHAR   Interface;
} USB_INTERFACE_DESCRIPTOR, *PUSB_INTERFACE_DESCRIPTOR;

// foCXNX͂̃f[^ɂȂ
typedef struct {
    UCHAR   InterfaceClass;
    UCHAR   InterfaceSubClass;
    UCHAR   InterfaceProtocol;
} USB_DEVICE_CLASS, *PUSB_DEVICE_CLASS;

#include <POPPACK.H>        //\̃pbN͂܂


class CUsbDevice
{

public:

    //USBoXfoCXhCõI[v
    BOOL UsbDeviceDriverOpen(VOID);

    //USBoXfoCXhCõN[Y
    VOID UsbDeviceDriverClose(VOID);

    //foCXNX̎擾
    BOOL GetUsbDeviceClass(USB_DEVICE_CLASS *UsbDeviceClass);

    //NXNGXg̔s
    BOOL IssueClassRequestPacket(CHAR *ControlTransferData,ULONG TransferLength);

    //oN]
    BOOL BulkTransfer(BOOL isRead, ULONG transferSize, PVOID transferBuffer,ULONG *transferCompleteLength);

    //foCXx̃`FbN
    ULONG IsDeviceHighSpeed(VOID);

    CUsbDevice();
    virtual ~CUsbDevice();

private:

    //foCXhConh

    HANDLE HandleOfUsbDeviceDriver;

    //C^[tF[XfBXNv^
    USB_INTERFACE_DESCRIPTOR InterfaceDescriptorOfDevice;

    //foCXt@C̃I[v
    HANDLE CreateDeviceFile( GUID* pGuid, ULONG instance,
					CHAR* filename);
};

#endif // !defined(AFX_USBDEVICE_H__76F02E71_1080_4373_97F9_D6AED0ABB9A4__INCLUDED_)
