// TestFile.cpp: CTestFile NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "usbtest.h"
#include "TestFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CTestFile::CTestFile()
{
	AtapiRequestParameter.DataBuffer=NULL;
}

CTestFile::~CTestFile()
{

}

LONG CTestFile::GetBCD(VOID)
{
	CHAR	data;
	LONG	length=0;	

	while(TRUE) {
		
		if (!TestFile.Read(&data,1)) {
			// t@CIG[ ƂĕԂ
			return INVALID_FILE_ERROR;
		}

		// f[^ȊOȂG[ƂȂ
		if (data < BCD_MIN_CODE || data > BCD_MAX_CODE) 
			break;
		
		// f[^𐔎ĂDꌅ̂10{Ă
		// āCĂ
		length *= 10;
		length += (LONG)(data - BCD_MIN_CODE);
	}

	return length;
}

BOOL CTestFile::IsThisDataHex(CHAR *data)
{
	BYTE checkData = *data;
	BOOL flag = FALSE;

	//  "0"`"9"Ȃ΃f[^0`9ɐݒ肷
	if (checkData >= BCD_MIN_CODE && checkData <= BCD_MAX_CODE) {
		*data = (checkData & DECIMAL_MASK);
		flag = TRUE;
	}

	ChangeLargeAlphabet(checkData); // 0x60 -> 0x40֕ϊ
	
	//  "A"`"F"Ȃ΃f[^10`15ɐݒ肷
	if (checkData >= 'A' && checkData <= 'F') {
		*data = 10 + (checkData - 'A');
		flag = TRUE;
	}

	return flag; // f[^16iłǂ̊mF
}

BOOL CTestFile::SearchTransferDirectionMark(VOID)
{
	CHAR	data;
	
	while(TRUE) {
		GetTestFileChar(data);
		if (data == '#')   {
			// f[^]̐ݒo
			break;			
		}
	}
	
	GetTestFileChar(data);	 // "-" ǂݎ̂Ă
	
	// p -> Ȃ΃CgɂȂ
	GetTestFileChar(data);
	if (data == '>')
		AtapiRequestParameter.isThisRequestRead = FALSE;
	else
		AtapiRequestParameter.isThisRequestRead = TRUE;

	// ]oCgǂݍ
	LONG TransferLength = GetBCD();
	if (TransferLength == INVALID_FILE_ERROR) return FALSE;

	// ]oCgݒ肷
	AtapiRequestParameter.TransferLength = (ULONG)TransferLength;

	return TRUE;
}

BOOL CTestFile::SearchAtapiRequestStartMark(VOID)
{
	CHAR	data;
	
	while(TRUE) {
		GetTestFileChar(data);
		if (data == '<')   {
			// ATAPIpPbg̋Lqo
			break;			
		}
	}

	return TRUE;
}

BOOL CTestFile::GetAtapiRequest(VOID)
{
	BOOL	isCommentValid=FALSE;
	CHAR	data;
	int		AtapiPacketAddress = 0,HexAddress = 0;

#define SET_ATAPI_PAKCET(a) AtapiRequestParameter.AtapiRequestPacket[a]
	
	// [vJn
	while(TRUE) {
		
		GetTestFileChar(data); 		// 1擾

		if (data == ';') 
			isCommentValid = TRUE;	 // RgJn
		if (data == ASCII_CR_CODE)
			isCommentValid = FALSE;	 // RgI
		if (data == '>') 
			break; // ATAPIR}hIȂ̂ŏ甲

		if (!isCommentValid) {
			
			// Rgł͂Ȃ̂ŏs
						
			if ( IsThisDataHex(&data) ) { // Mf[^16iǂ𔻒f
				
				// 16iȂΏʂɃZbg
				SET_ATAPI_PAKCET(AtapiPacketAddress)
					= (CHAR)(data * 16);
				
				// ̃f[^ʂɃZbg
				GetTestFileChar(data);
				IsThisDataHex(&data);
				SET_ATAPI_PAKCET(AtapiPacketAddress++)
					+= (CHAR)data;
				
				// SpPbgM犮
				if (AtapiPacketAddress >= 
					ATAPI_COMMAND_REQUEST_LENGTH)
						break;
			}
		}
	}	

	return TRUE;
}

BOOL CTestFile::SearchDataDescriptStartMark()
{
	CHAR	data;
	
	while(TRUE) {
		GetTestFileChar(data);
		if (data == '[')   {
			// o̓f[^̋Lqo
			break;			
		}
	}

	return TRUE;
}

BOOL CTestFile::GetTransferData(VOID)
{
	BOOL	isCommentValid=FALSE;
	CHAR	data;
	CHAR	*DataBuffer = AtapiRequestParameter.DataBuffer;
	ULONG	RemainderDataBytes = AtapiRequestParameter.TransferLength;
	
	// [vJn
	while(TRUE) {
		
		GetTestFileChar(data); 	// 1擾

		if (data == ';')
			isCommentValid = TRUE; // RgJn
		if (data == ASCII_CR_CODE)
			isCommentValid = FALSE; // RgI
		if (data == ']')
			break; 		// f[^Îŏ甲

		if (!isCommentValid) { // Mf[^16iǂ𔻒f

			// Rgł͂Ȃ̂ŏs

			if ( IsThisDataHex(&data) ) {
				// 16iȂΏʂɃZbg
				*DataBuffer	= (CHAR)(data * 16);
				
				// ̃f[^ʂɃZbg
				GetTestFileChar(data);
				IsThisDataHex(&data);
				*DataBuffer += (CHAR)data;
				
				DataBuffer++;

				// Sf[^Rs[犮
				RemainderDataBytes--;
				if (!RemainderDataBytes)
						break;
			}
		}
	}	

	return TRUE;
}

BOOL CTestFile::ChoiceFileNotice(CString SelectFileName)
{
#define CHOICE_FILE_NOTICE_ERROR { success=FALSE; goto ChoiceFileNoticeExit; }
	
	BOOL	success=TRUE;

	AtapiRequestParameter.DataBuffer = NULL;

	// ܂̓f[^ރt@C߂
	WriteDataFileName = SelectFileName;
	WriteDataFileName += ".utd";

	// eXgt@CI[v
	TestFile.Open(SelectFileName,CFile::modeRead);

	// ]`FbNCTCYmۂ
	if ( !SearchTransferDirectionMark() ) CHOICE_FILE_NOTICE_ERROR

	// "<" o
	if ( !SearchAtapiRequestStartMark() ) CHOICE_FILE_NOTICE_ERROR
	
	// ATAPIR}hpPbg擾
	if ( !GetAtapiRequest() ) CHOICE_FILE_NOTICE_ERROR
	
	
	if (AtapiRequestParameter.TransferLength) {

		// ]f[^΁Cf[^obt@mۂ
		AtapiRequestParameter.DataBuffer =
			(CHAR *)malloc(AtapiRequestParameter.TransferLength);
		if (!AtapiRequestParameter.DataBuffer) CHOICE_FILE_NOTICE_ERROR
	
		if ( !AtapiRequestParameter.isThisRequestRead ) {
			// Cg̏ꍇ͂̃f[^擾
			if ( !SearchDataDescriptStartMark() ) CHOICE_FILE_NOTICE_ERROR
			if ( !GetTransferData() ) CHOICE_FILE_NOTICE_ERROR
		}
		else {
			// [h̏ꍇ0NAĂ
			memset(AtapiRequestParameter.DataBuffer,0,
					AtapiRequestParameter.TransferLength);
		}
	}

	// ]TCY0NA
		AtapiRequestParameter.TransferCompleteLength = 0;

ChoiceFileNoticeExit:

	// eXgt@CN[Y
	TestFile.Close();
	 
	return success;
}

ATAPI_REQUEST_PARAMETER* CTestFile::GetAtapiRequestParameter(VOID)
{
	return &AtapiRequestParameter;
}

VOID CTestFile::WriteDataToFile(VOID)
{
	if ( !AtapiRequestParameter.DataBuffer) return;

	// ATAPINGXgp[^̃obt@̓e
	// t@Cɏ

	WriteDataFile.Open(WriteDataFileName, CFile::modeCreate | CFile::modeWrite);
	
	WriteDataFile.Write(
		AtapiRequestParameter.DataBuffer,
		AtapiRequestParameter.TransferCompleteLength);

	WriteDataFile.Close();
}

VOID CTestFile::ReleaseAtapiRequestParameter(VOID)
{
	// ATAPINGXgp[^NAC
	if (AtapiRequestParameter.DataBuffer)
		free(AtapiRequestParameter.DataBuffer);
	memset(&AtapiRequestParameter,0,sizeof(ATAPI_REQUEST_PARAMETER));
}

