// UsbStorageDevice.h: CUsbStorageDevice NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_USBSTORAGEDEVICE_H__0406994D_02F2_4666_A9A8_F0FD0135107F__INCLUDED_)
#define AFX_USBSTORAGEDEVICE_H__0406994D_02F2_4666_A9A8_F0FD0135107F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// USBfoCXփANZX
#include "UsbDevice.h"

// Xg[WfoCXɊւ`
// Ŏg
#define ATAPI_COMMAND_REQUEST_LENGTH 12
#define INQUIRY_PRODUCT_NAME_LENGTH 16
#define BULK_ONLY_DEVICE_PROTOCOL 0x50

#include <PSHPACK1.H>       //\̂pbN

// RequestSensef[^ 
typedef struct {
    CHAR    ErrorCode;
    CHAR    Segment;
    CHAR    SenseKey;
    ULONG   Information;
    CHAR    Length;
    CHAR    Info2[4];
    CHAR    ASC;
    CHAR    ASCQ;
    CHAR    Reserved;
    CHAR    SKSV;
    USHORT  Progress;
} RequestSenseData, *pRequestSenseData;

// ReadCapacityf[^
typedef struct {
    ULONG   BlockLength;
    ULONG   BlockAddress;
} CapacityData, *pCapacityData;

#include <POPPACK.H>        //\̃pbN͂܂

class CUsbStorageDevice
{
public:
    CUsbStorageDevice();
    virtual ~CUsbStorageDevice();

    // f[^̑Mi͂Ŏj
    BOOL TransferData(BOOL isRead, ULONG transferSize, PVOID 
transferBuffer,ULONG *transferCompleteLength);

    // Xg[WfoCX̏
    virtual BOOL DeviceInitialize(CUsbDevice* InitializeUsbDevice)=0;

    //ATAPIR}hpPbgfoCXɑM
    virtual BOOL SendAtapiRequestPacket(PVOID atapi,ULONG 
					TransferDataLength,BOOL isRead)=0;

    //Xe[^X̎擾
    virtual BOOL GetStorageDeviceStatus(VOID)=0;

protected:
    CUsbDevice* UsbDevice;

};

#endif // !defined(AFX_USBSTORAGEDEVICE_H__0406994D_02F2_4666_A9A8_F0FD0135107F__INCLUDED_)
